import type { ICollectionDocument } from "./ICollectionDocument.js";
export declare enum CrudOperations {
    None = 0,
    Create = 1,// 1
    Read = 2,// 2
    Update = 4,// 4
    Delete = 8,// 8
    FullAccess = 15
}
export declare enum RoleNames {
    Admin = "Admin",
    GroupAdmin = "GroupAdmin",
    User = "User",
    Guest = "Guest",
    Anonymous = "Anonymous"
}
export declare enum Topics {
    AppSettings = "AppSettings",
    ProjectLibrary = "ProjectLibrary",
    VideoLibrary = "VideoLibrary",
    AudioLibrary = "AudioLibrary",
    ImageLibrary = "ImageLibrary",
    FontLibrary = "FontLibrary",
    AnimationLibrary = "AnimationLibrary",
    SubtitleLibrary = "SubtitleLibrary",
    RenderedVideoLibrary = "RenderedVideoLibrary"
}
export interface IAppSettings extends ICollectionDocument {
    roles: IRole[];
}
export interface IRole {
    name: RoleNames;
    permissions: IPermission[];
}
export interface IPermission {
    topic: Topics;
    allowedOperations: CrudOperations;
}
//# sourceMappingURL=IAppSettings.d.ts.map