import { isSmaller } from "../extensions/index.js";
import { WebVTT } from "../models/index.js";
import { textsFromProperty } from "./IProperty.js";
export function iEditSpecificationToAlgolia(item) {
    var _a, _b;
    const clipTexts = (_b = (_a = item.clips) === null || _a === void 0 ? void 0 : _a.map(textsFromClip).flat()) !== null && _b !== void 0 ? _b : [];
    return {
        selectors: item.selectors,
        videoSettings: item.videoSettings,
        text: [...clipTexts],
    };
}
function textsFromClip(clip) {
    const texts = [];
    if (clip.name)
        texts.push(clip.name);
    clip.layers.forEach((layer) => {
        if (layer.name)
            texts.push(layer.name);
        if (layer.subtitlesLocale) {
            layer.subtitlesLocale.forEach((sub) => {
                if (sub.value && isSmaller(texts, 0.6)) {
                    const webVtt = WebVTT.fromIWebVTT(sub.value);
                    texts.push(...webVtt.extractTexts());
                }
            });
        }
        if (layer.propertiesLocale) {
            layer.propertiesLocale.forEach((locale) => {
                locale.value
                    .filter((x) => x.type === "text")
                    .forEach((prop) => {
                    texts.push(...textsFromProperty(prop));
                });
            });
        }
    });
    return texts;
}
//# sourceMappingURL=IEditSpecification.js.map