import { z } from "zod";
import { Anchor } from "../enums/index.js";
export interface IFrameRange {
    start: number;
    end: number;
    anchor?: Anchor | null;
}
export declare const IFrameRangeSchema: z.ZodObject<{
    start: z.ZodNumber;
    end: z.ZodNumber;
    anchor: z.ZodOptional<z.ZodNullable<z.ZodEnum<[Anchor.Start, Anchor.Center, Anchor.End]>>>;
}, "strip", z.ZodTypeAny, {
    start: number;
    end: number;
    anchor?: Anchor | null | undefined;
}, {
    start: number;
    end: number;
    anchor?: Anchor | null | undefined;
}>;
//# sourceMappingURL=IFrameRange.d.ts.map