import { sanitizeICreateUpdate } from "./ICreataUpdate.js";
import { missingGroupClaims, removedGroupClaims } from "../models/hasUsers.js";
export function addGroup(item, groupId) {
    const clone = Object.assign({}, item);
    const claim = `grp:${groupId.replace("grp:", "")}`;
    if (!clone.groups)
        clone.groups = [];
    if (clone.groups.includes(claim))
        return clone;
    item.groups = [...clone.groups, claim];
    return clone;
}
export function removeGroup(item, groupId) {
    var _a;
    const clone = Object.assign({}, item);
    const claimWithoupPrefix = groupId.replace("grp:", "");
    if (!clone.groups)
        return clone;
    clone.groups =
        (_a = clone.groups.filter((grp) => !grp.includes(claimWithoupPrefix))) !== null && _a !== void 0 ? _a : [];
    return clone;
}
export function iHasUserCreataUpdateToAlgolia(item) {
    var _a, _b;
    const groups = [];
    if (item.groups && Array.isArray(item.groups)) {
        for (const group of item.groups) {
            groups.push(group.replace("grp:", ""));
        }
    }
    return {
        users: (_a = item.users) !== null && _a !== void 0 ? _a : [],
        groups,
        groupClaims: (_b = item.groupClaims) !== null && _b !== void 0 ? _b : {},
        // createdBy: item.createdBy,
        // updatedBy: item.updatedBy,
        // createdAt: item.createdAt,
        // updatedAt: item.updatedAt,
    };
}
export function sanitizeIHasUser(item) {
    let changed = false;
    if (!item.groups) {
        item.groups = [];
        changed = true;
    }
    if (!item.users) {
        item.users = [];
        changed = true;
    }
    if (!item.groupClaims) {
        item.groupClaims = { claims: false };
        changed = true;
    }
    return changed;
}
export function sanitizeIHasUserCreataUpdate(item) {
    const changed1 = sanitizeIHasUser(item);
    const changed2 = sanitizeICreateUpdate(item);
    return changed1 || changed2;
}
export function sanitizeGroupClaims(document) {
    var _a, _b;
    let sanitizeChanged = false;
    const missingClaims = missingGroupClaims(document);
    const removedClaims = removedGroupClaims(document);
    if (missingClaims.length > 0) {
        sanitizeChanged = true;
        document.groupClaims = Object.assign({}, ((_a = document.groupClaims) !== null && _a !== void 0 ? _a : { claims: false }));
        for (const claim of missingClaims) {
            document.groupClaims[claim] = true;
        }
    }
    if (removedClaims.length > 0) {
        sanitizeChanged = true;
        document.groupClaims = Object.assign({}, ((_b = document.groupClaims) !== null && _b !== void 0 ? _b : { claims: false }));
        for (const claim of removedClaims) {
            // console.log("Remove Claim: ", claim);
            delete document.groupClaims[claim];
            // console.log("Removed: ", document.groupClaims);
        }
    }
    const clone = Object.assign({}, document);
    return { document: clone, sanitizeChanged };
}
//# sourceMappingURL=IHasUsers.js.map