import { MediaType } from "./IMediaAsset.js";
import { MetadataType } from "./IMetadata.js";
export type AssetKey = {
    id: string;
    mediaType: MediaType;
};
export type TypeParamIndexKey = {
    type: string;
    param: string;
    index: number;
};
export type LanguageTextKey = {
    languageCode: string;
    text: string;
};
export type LanguageVersionKey = {
    languageCode: string;
    version: number;
};
export type LanguageVersionParamKey = {
    languageCode: string;
    version: number;
    param: string;
};
export type LanguageKey = {
    languageCode: string;
};
export interface IVariant<K, T> {
    key: K;
    value: T;
    LOCKED?: boolean;
}
export interface ILocalCloudFile {
    filename: string;
    localPath?: string;
    cloudPath?: string;
    cloudDownloadPath?: string;
    fileMetadata?: MetadataType[];
    jsonData?: string;
    variants?: IVariant<LanguageVersionKey, ILocalCloudFile>[];
}
export interface ILocalCloudFileAlgolia {
    filename: string;
    texts?: string[];
    fileMetadata?: any[];
    jsonData?: string;
    variants?: ILocalCloudFileAlgolia[] | null;
}
export declare function iLocalCloudFileToAlgolia(item: ILocalCloudFile, mediaType?: MediaType): ILocalCloudFileAlgolia | null;
//# sourceMappingURL=ILocalCloudFile.d.ts.map