import * as uuid from "uuid";
import { setParent } from "./IHasParentChildRelationship.js";
export function iMetadataItem(data, parent, subCollection = "Data") {
    const parentRef = parent.documentReference;
    const parentsCollection = {
        parent: parentRef,
        path: `${parentRef.path}/${subCollection}`,
    };
    const id = uuid.v4();
    const documentReference = {
        id,
        path: `${parentsCollection.path}/${id}`,
        parent: parentsCollection,
    };
    const metadata = Object.assign(Object.assign({}, data), { parentReference: parentRef, documentReference, createdBy: "cloudFunction", createdAt: new Date() });
    setParent(metadata, parentRef);
    metadata.users = parent.users;
    metadata.groups = parent.groups;
    return metadata;
}
//# sourceMappingURL=IMetadata.js.map