import { type IEditSpecification, type IEditSpecificationAlgolia } from "./IEditSpecification.js";
import type { IVideoSettings } from "./IVideoSettings.js";
import type { ILocalCloudFile } from "./ILocalCloudFile.js";
import type { IDocumentReference } from "./IDocumentReference.js";
import { type ICollectionDocument, type ICollectionDocumentAlgolia } from "./ICollectionDocument.js";
export interface IProject extends ICollectionDocument {
    name: string;
    description: string;
    keywords: string;
    mainLanguage: string;
    additionalLanguages?: string[];
    subtitleActive: boolean;
    progress: number;
    isFinished: boolean;
    videoSettings: IVideoSettings;
    editSpecification?: IEditSpecification;
    editSpecificationJson?: string;
    previewStripeFile?: ILocalCloudFile;
    libraryItems?: string[];
    myVideoIds: string[];
    renderedVideos: IDocumentReference[];
}
export interface IProjectAlgolia extends ICollectionDocumentAlgolia {
    id: string;
    name: string;
    description: string;
    keywords: string;
    mainLanguage: string;
    additionalLanguages?: string[];
    videoSettings: IVideoSettings;
    editSpecification?: IEditSpecificationAlgolia;
}
export declare function iProjectToAlgolia(item: IProject): IProjectAlgolia;
//# sourceMappingURL=IProject.d.ts.map