import type { IAudioClip, ITitle, ILowerThird, ICollectionDocument, ICollectionDocumentId, IMediaAsset, IVideoSettings } from "./index.js";
export interface IProjectElementSlim extends ICollectionDocumentId {
    uid: string;
    name: string;
    description: string;
    text1: string;
    text2: string;
    isFinished: boolean;
    isLandscape: boolean;
    isMovable: boolean;
    maxLength: number;
    type: number;
    videoSettings: IVideoSettings;
    selectedAsset: IMediaAsset;
    uploadedAsset: IMediaAsset;
    assets: IMediaAsset[];
    backgroundAudio: IAudioClip;
    clipTitle: ITitle;
    lowerThird: ILowerThird;
}
export interface IProjectElement extends ICollectionDocument {
    uid: string;
    name: string;
    description: string;
    text1: string | null;
    text2: string | null;
    isFinished: boolean;
    isLandscape: boolean;
    isMovable: boolean;
    maxLength: number | null;
    type: number;
    videoSettings: IVideoSettings;
    selectedAsset: IMediaAsset | null;
    uploadedAsset: IMediaAsset | null;
    assets: IMediaAsset[];
    backgroundAudio: IAudioClip | null;
    clipTitle: ITitle | null;
    lowerThird: ILowerThird | null;
}
//# sourceMappingURL=IProjectElement.d.ts.map