import type { IEditSpecification } from "./IEditSpecification.js";
import { IEditSpecificationAlgolia } from "./IEditSpecification.js";
import type { IMediaAsset, IMediaAssetAlgolia } from "./IMediaAsset.js";
import { type ICollectionDocument, type ICollectionDocumentAlgolia } from "./ICollectionDocument.js";
import { IDocumentReference } from "./IDocumentReference.js";
import { IVariant, LanguageVersionParamKey } from "./ILocalCloudFile.js";
import { IVideoSettings, IImageSettings } from "./IVideoSettings.js";
export declare enum RenderedVideoState {
    null = "",
    Created = "Created",
    StartEdit = "StartEdit",
    Editing = "Editing",
    Edited = "Edited",
    Finished = "Finished",
    Error = "Error"
}
export interface IRenderedVideo extends ICollectionDocument {
    state: RenderedVideoState;
    projectName: string;
    description?: string;
    projectReference: IDocumentReference | null;
    editSpecification: IEditSpecification | null;
    videoSettings: IVideoSettings | null;
    languageCodes: string[] | null;
    ratios: IImageSettings[] | null;
    subtitle: {
        blank: boolean;
        withSubtitle: boolean;
    } | null;
    videoCount: number;
    normalizedCount: number;
    createdAsset: IMediaAsset | null;
    createdAssets: IVariant<LanguageVersionParamKey, IMediaAsset>[] | null;
}
export interface IRenderedVideoAlgolia extends ICollectionDocumentAlgolia {
    id: string;
    state: string;
    projectName: string;
    projectReference: IDocumentReference | null;
    editSpecification: IEditSpecificationAlgolia | null;
    videoSettings: IVideoSettings | null;
    languageCodes: string[] | null;
    createdAsset: IMediaAssetAlgolia | null;
    createdAssets: IMediaAssetAlgolia[] | null;
}
export declare function iRenderedVideoToAlgolia(item: IRenderedVideo): IRenderedVideoAlgolia;
//# sourceMappingURL=IRenderedVideo.d.ts.map