export var PipeNames;
(function (PipeNames) {
    PipeNames["audioMetadataUpdatedPipe"] = "audioMetadataUpdatedPipe";
    PipeNames["extractAudioPipe"] = "extractAudioPipe";
    PipeNames["translateProjectFactory"] = "translateProjectFactory";
    PipeNames["translateSubtitleLibraryItemFactory"] = "translateSubtitleLibraryItemFactory";
    PipeNames["previewPipe"] = "previewPipe";
    PipeNames["translateProjectPipe"] = "translateProjectPipe";
    PipeNames["translateSubtitleLibraryItemPipe"] = "translateSubtitleLibraryItemPipe";
    PipeNames["videoUploadedPipe"] = "videoUploadedPipe";
    PipeNames["videoMetadataUpdatedPipe"] = "videoMetadataUpdatedPipe";
})(PipeNames || (PipeNames = {}));
export function argStrings(args, key, defaultValue = []) {
    if (!args)
        return defaultValue;
    const argument = args[key];
    // Is a string[]
    if (args && Array.isArray(argument)) {
        return argument.map((x) => x.toString());
    }
    return defaultValue;
}
export function argObjects(args, key, defaultValue = []) {
    if (!args)
        return defaultValue;
    const argument = args[key];
    if (args && Array.isArray(argument)) {
        return argument.map((x) => JSON.parse(JSON.stringify(x)));
    }
    return defaultValue;
}
export function argObject(args, key, defaultValue) {
    if (!args)
        return defaultValue;
    const rootArg = args[key];
    if (args && typeof rootArg === "object") {
        return JSON.parse(JSON.stringify(rootArg));
    }
    return defaultValue;
}
export function argNumber(args, key, defaultValue) {
    if (!args)
        return defaultValue;
    const argument = args[key];
    if (args && typeof argument === "string") {
        return parseInt(argument, 10);
    }
    if (args && typeof argument === "number") {
        return argument;
    }
    return defaultValue;
}
export function argString(args, key, defaultValue) {
    if (!args)
        return defaultValue;
    const argument = args[key];
    if (args && typeof argument === "string") {
        return argument;
    }
    return defaultValue;
}
export var TaskFunction;
(function (TaskFunction) {
    TaskFunction["map"] = "map";
    TaskFunction["forEach"] = "forEach";
    TaskFunction["none"] = "none";
    TaskFunction["updateDocument"] = "updateDocument";
    TaskFunction["fetchText"] = "fetchText";
    TaskFunction["downloadFile"] = "downloadFile";
    TaskFunction["downloadFromUrl"] = "downloadFromUrl";
    TaskFunction["uploadFile"] = "uploadFile";
    TaskFunction["createTextFile"] = "createTextFile";
    TaskFunction["setMetadata"] = "setMetadata";
    TaskFunction["getMetadata"] = "getMetadata";
    TaskFunction["renderThumbnail"] = "renderThumbnail";
    TaskFunction["renderPreview"] = "renderPreview";
    TaskFunction["extractAudio"] = "extractAudio";
    TaskFunction["extractVideoMetadata"] = "extractVideoMetadata";
    TaskFunction["doublePassNormalization"] = "doublePassNormalization";
    TaskFunction["convertVideoToH264"] = "convertVideoToH264";
    TaskFunction["startTranscoderApiJob"] = "startTranscoderApiJob";
    TaskFunction["transcribeAudioToBucket"] = "transcribeAudioToBucket";
    TaskFunction["ITranscriptionResultToSrt"] = "ITranscriptionResultToSrt";
    TaskFunction["transcribeAudio"] = "transcribeAudio";
    TaskFunction["gladiaTranscribeUrl"] = "gladiaTranscribeUrl";
    TaskFunction["gladiaTranscribeLocalAudio"] = "gladiaTranscribeLocalAudio";
    TaskFunction["IGladiaResultToITranscriptionResult"] = "IGladiaResultToITranscriptionResult";
    TaskFunction["ITranscriptionResultContainerToSubtitleAsset"] = "IGladiaTranscriptionResultToSubtitleAsset";
    TaskFunction["ITranscriptionResultContainerUpdateSubtitleAsset"] = "ITranscriptionResultContainerUpdateSubtitleAsset";
    TaskFunction["srtToSubtitleAsset"] = "srtToSubtitleAsset";
    TaskFunction["jsonToVTT"] = "jsonToVTT";
    TaskFunction["jsonToSRT"] = "jsonToSRT";
    TaskFunction["labelVideo"] = "labelVideo";
    TaskFunction["translateText"] = "translateText";
    TaskFunction["translateIEditSpecification"] = "translateIEditSpecification";
    TaskFunction["insertTranslationStoreIntoIEditSpecification"] = "insertTranslationStoreIntoIEditSpecification";
    TaskFunction["translateVTT"] = "translateVTT";
    TaskFunction["translateJson"] = "translateJson";
    TaskFunction["renderVideo"] = "renderVideo";
    TaskFunction["setFFmpegMetadata"] = "setFFmpegMetadata";
})(TaskFunction || (TaskFunction = {}));
//# sourceMappingURL=ITask.js.map