export const DEFAULT_UI_SETTINGS = {
    leftExpanded: true,
    leftSize: 400,
    rightExpanded: true,
    rightSize: 400,
    bottomExpanded: true,
    bottomSize: 250,
};
export const DEFAULT_GENERAL_SETTINGS = {
    loadProjectOnStartup: true,
};
export const DEFAULT_LIBRARY_SETTINGS = [];
export const DEFAULT_PLAYER_SETTINGS = {
    playOnClick: true,
    autoplay: false,
    loop: false,
    muted: false,
    volume: 1,
    playbackRate: 1,
};
export const DEFAULT_TIMELINE_SETTINGS = {
    skimming: true,
    snapping: true,
};
export const DEFAULT_LANGUAGE_SETTINGS = {
    defaultMainLanguage: "en",
    defaultTranslationLanguages: ["de", "ja"],
    dictionary: [],
};
export const DEFAULT_WORKER_SETTINGS = {
    onAssetUploaded: {
        video: {
            name: "video",
            icon: "video_library",
            active: true,
            subtasks: [
                {
                    name: "Normalize",
                    icon: "graphic_eq",
                    active: true,
                },
                {
                    name: "Transcribe",
                    icon: "closed_caption",
                    active: true,
                },
            ],
        },
        audio: {
            name: "audio",
            icon: "volume_up",
            active: true,
            subtasks: [
                {
                    name: "Normalize",
                    icon: "graphic_eq",
                    active: false,
                },
                {
                    name: "Transcribe",
                    icon: "closed_caption",
                    active: true,
                },
            ],
        },
        image: {
            name: "image",
            icon: "image",
            active: false,
        },
        subtitle: {
            name: "subtitle",
            icon: "closed_caption",
            active: true,
            subtasks: [
                {
                    name: "Translate",
                    icon: "translate",
                    active: false,
                },
            ],
        },
    },
};
export const DEFAULT_USER_SETTINGS = {
    id: "",
    selectedWorkgroup: null,
    generalSettings: DEFAULT_GENERAL_SETTINGS,
    languageSettings: DEFAULT_LANGUAGE_SETTINGS,
    playerSettings: DEFAULT_PLAYER_SETTINGS,
    timelineSettings: DEFAULT_TIMELINE_SETTINGS,
    librarySettings: DEFAULT_LIBRARY_SETTINGS,
    workerSettings: DEFAULT_WORKER_SETTINGS,
};
//# sourceMappingURL=IUserSettings.js.map