export function aspectFit(width, height, parentWidth, parentHeight) {
    if (width <= 0 || height <= 0 || parentWidth <= 0 || parentHeight <= 0)
        throw new Error('Input parameter must be positive numbers');
    const scale = Math.min(parentWidth / width, parentHeight / height);
    const newWidth = width * scale;
    const newHeight = height * scale;
    return { scale, width: newWidth, height: newHeight };
}
export function aspectFill(width, height, parentWidth, parentHeight) {
    if (width <= 0 || height <= 0 || parentWidth <= 0 || parentHeight <= 0)
        throw new Error('Input parameter must be positive numbers');
    const scale = Math.max(parentWidth / width, parentHeight / height);
    const newWidth = width * scale;
    const newHeight = height * scale;
    return { scale, width: newWidth, height: newHeight };
}
//# sourceMappingURL=aspect.js.map