import "reflect-metadata";
import { immerable } from "immer";
import { Aspect } from "../enums/index.js";
import { Position } from "./position.js";
import { CssValue } from "./cssValue.js";
import { NormalizedSize } from "./normalizedSize.js";
import { PercentSize } from "./percentSize.js";
export declare class BoxModel {
    name: string;
    [immerable]: boolean;
    private _position;
    get position(): Position;
    set position(value: Position);
    get percentPosition(): Position;
    private _size;
    get size(): NormalizedSize;
    set size(value: NormalizedSize);
    get percentSize(): PercentSize;
    aspect: Aspect;
    top: CssValue;
    bottom: CssValue;
    left: CssValue;
    right: CssValue;
    width: CssValue;
    height: CssValue;
    get topLeftWidthHeight(): {
        position: import("../enums/general.js").PositionType;
        top: string;
        left: string;
        width: string;
        height: string;
    };
    constructor(position: Position, size: NormalizedSize, name?: string);
    setBox(): void;
    getBoxInPercent(): {
        left: CssValue;
        top: CssValue;
        right: CssValue;
        bottom: CssValue;
    };
    withPosition(position: Position): BoxModel;
    withSize(size: NormalizedSize): BoxModel;
    clone(): BoxModel;
    update(fn: (box: BoxModel) => void): void;
    static fromTopLeftWidthHeight(leftPercent?: number, topPercent?: number, width?: number, height?: number): BoxModel;
    static default(name?: string): BoxModel;
    static defaultCenter(name?: string): BoxModel;
}
//# sourceMappingURL=boxModel.d.ts.map