import { CSSProperties } from "react";
import { immerable } from "immer";
import { Box } from "./box.js";
declare enum CssUnit {
    "millimeters" = "mm",
    "centimeters" = "cm",
    "inches" = "in",
    "pixel" = "px",
    "points" = "pt",
    "picas" = "pc",
    "em" = "em",
    "rem" = "rem",
    "ex" = "ex",
    "ch" = "ch",
    "viewportWidth" = "vw",
    "viewportHeight" = "vh",
    "vMin" = "vmin",
    "vMax" = "vmax",
    "percent" = "%"
}
export declare class BoxStyle {
    [immerable]: boolean;
    unit: CssUnit;
    box: Box;
    constructor(box: Box);
    /**
     * Generates the CSS properties required to style an HTML element
     * based on the Box model's properties, using projectToParentSpace.
     *
     * @returns {CSSProperties} The calculated CSS properties.
     */
    getStyleInPercent(applyScalingEffect?: boolean): CSSProperties;
}
export {};
//# sourceMappingURL=boxStyle.d.ts.map