import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useCallback } from "react";
import { AbsoluteFill } from "remotion";
import { SortedOutlines } from "./sorted-outlines.js";
import { DnDLayer } from "./dnd-layer.js";
const outer = {
    backgroundColor: "transparent",
};
const layerContainer = {
    overflow: "hidden",
};
export const DnDComponent = ({ items, selectedItem, setSelectedItem, changeItem, config, }) => {
    const onPointerDown = useCallback((e) => {
        if (e.button !== 0) {
            return;
        }
        setSelectedItem(null);
    }, [setSelectedItem]);
    return (_jsxs(AbsoluteFill, { style: outer, onPointerDown: onPointerDown, children: [_jsx(AbsoluteFill, { style: layerContainer, children: items.map((item) => {
                    return _jsx(DnDLayer, { item: item, config: config }, item.id);
                }) }), _jsx(SortedOutlines, { config: config, selectedItem: selectedItem, items: items, setSelectedItem: setSelectedItem, changeItem: changeItem })] }));
};
//# sourceMappingURL=dnd-component.js.map