import React from "react";
import type { DnDConfig, DragAndDropItem } from "./type.js";
export declare const DnDLayer: React.FC<{
    item: DragAndDropItem;
    config: DnDConfig;
}>;
/**
 * Generates a spatial style object for a drag-and-drop item.
 *
 * @param item - The drag-and-drop item containing spatial properties.
 * @returns An object containing the CSS properties: left, top, width, height, and zIndex.
 */
export declare function spacialStyle(item: DragAndDropItem): {
    left: string | number;
    top: string | number;
    width: string | number;
    height: string | number;
    zIndex: number | undefined;
};
//# sourceMappingURL=dnd-layer.d.ts.map