import "reflect-metadata";
import React from "react";
import { z } from "zod";
import { CalculateMetadataFunction } from "remotion";
import { VideoStripPropsSchema } from "../../schema/index.js";
import type { ISelectors, IVideoSettings } from "../../interfaces/index.js";
import { Clip } from "../clip.js";
import { EditSpecification } from "../editSpecification.js";
import { DnDProps } from "./drag-and-drop/index.js";
export interface IVideoStripProps {
    editSpecificationJson: string;
    editSpecification: EditSpecification;
    videoSettings: IVideoSettings;
    clips: Clip[];
}
export type VideoStripProps = {
    editSpecificationJson: string;
    editSpecification: EditSpecification;
    videoSettings: IVideoSettings;
    clips: Clip[];
    dndProps?: DnDProps;
};
export declare function getVideoStripLength(editSpecification: EditSpecification, videoSettings: IVideoSettings): number;
export declare function calculateClips(props: VideoStripProps): Clip[];
export declare const calculateMetadata: CalculateMetadataFunction<any>;
export declare function calculateClipSequence(clips: Clip[], selectors: ISelectors): React.JSX.Element[];
export declare const VideoStrip: React.FC<z.infer<typeof VideoStripPropsSchema>>;
//# sourceMappingURL=video-strip.d.ts.map