import { immerable } from "immer";
import { ITextSettings } from "../interfaces/index.js";
import { CssUnit } from "../enums/index.js";
export declare class CssValue {
    [immerable]: boolean;
    value: number;
    unit: CssUnit;
    toString: () => string;
    static fromPercent(valueInPercent: number): CssValue;
    static fromPixel(pixel: number): CssValue;
    static getCanvas(): HTMLCanvasElement | {
        getContext: (contextId: "2d", options?: CanvasRenderingContext2DSettings | undefined) => any;
    };
    /**
     * Uses canvas.measureText to compute and return the width of the given text of given font in pixels.
     *
     * @param {String} text The text to be rendered.
     * @param {String} font The css font descriptor that text is to be rendered with (e.g. "bold 14px verdana").
     *
     * @see https://stackoverflow.com/questions/118241/calculate-text-width-with-javascript/21015393#21015393
     */
    static measureTextWidth(text: string, font?: string): number;
    static getTextWidth(text: string, fontFamily: string, fontSize: string, fontWeight: string): number;
    static getTextWidthFromITextSettings(text: string, settings: ITextSettings): number;
    /**
     * Uses canvas.measureText to compute and return the width of the given text of given font in pixels.
     *
     * @param {String} text The text to be rendered.
     * @param {String} font The css font descriptor that text is to be rendered with (e.g. "bold 14px verdana").
     *
     * @see https://stackoverflow.com/questions/118241/calculate-text-width-with-javascript/21015393#21015393
     */
    static measureTextHeight(text: string, font: string): number;
    static getTextHeight(text: string, fontFamily: string, fontSize: string, fontWeight: string): number;
    static getTextHeightFromITextSettings(text: string, settings: ITextSettings): number;
}
//# sourceMappingURL=cssValue.d.ts.map