var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a;
/* eslint-disable capitalized-comments */
import "reflect-metadata";
import _ from "lodash";
import hash from "object-hash";
import { fromFetch } from "rxjs/fetch";
import { forkJoin, map, mergeMap, of } from "rxjs";
import { instanceToPlain, plainToInstance, Type } from "class-transformer";
import { immerable, produce } from "immer";
import { subDocument } from "../index.js";
import { LayerType } from "../enums/index.js";
import { compareableLayer, DEFAULT_VIDEO_SETTINGS, MediaType, } from "../interfaces/index.js";
import { MediaAssetVariant } from "./mediaAsset.js";
import { FrameRange } from "./frameRange.js";
import { Clip } from "./clip.js";
import { WebVTT } from "./webVTT.js";
import { SubtitleLayer } from "./layer/subtitle.layer.js";
import { LibraryItem } from "./library-item.js";
import { layerFromILayer } from "./layer/layer.factory.js";
import { Box } from "./boxModel/index.js";
export class EditSpecification {
    // #region Dervived Properties
    get language() {
        if (typeof this.selectors.language === "string")
            return this.selectors.language;
        return "en";
    }
    set language(language) {
        this.selectors.language = language;
    }
    get videoSettings() {
        return this._videoSettings;
    }
    set videoSettings(videoSettings) {
        if (!videoSettings)
            return;
        const intermediate = Object.assign({}, videoSettings);
        intermediate.durationInFrames = Math.round(Math.max(1, videoSettings.durationInFrames));
        intermediate.width = Math.round(Math.max(1, videoSettings.width));
        intermediate.height = Math.round(Math.max(1, videoSettings.height));
        intermediate.frameRate = Math.max(1, videoSettings.frameRate);
        this._videoSettings = Object.assign(Object.assign({}, DEFAULT_VIDEO_SETTINGS), intermediate);
    }
    get fps() {
        return this._videoSettings.frameRate;
    }
    set fps(fps) {
        this._videoSettings.frameRate = Math.max(1, fps);
    }
    get width() {
        return this._videoSettings.width;
    }
    set width(width) {
        this._videoSettings.width = Math.max(1, width);
    }
    get height() {
        return this._videoSettings.height;
    }
    set height(height) {
        this._videoSettings.height = Math.max(1, height);
    }
    get durationInFrames() {
        return this._videoSettings.durationInFrames;
    }
    set durationInFrames(durationInFrames) {
        this._videoSettings.durationInFrames = Math.max(1, durationInFrames);
    }
    get libraryItems() {
        return this.clips.reduce((acc, clip) => {
            clip.layers.forEach((layer) => {
                if (layer.libId)
                    acc.push(layer.libId);
            });
            return acc;
        }, []);
    }
    get comparableClips() {
        return this.clips.map((clip) => {
            const comparable = _.cloneDeep(clip);
            comparable.layers = clip.layers.map((layer) => compareableLayer(layer));
            return comparable;
        });
    }
    // #endregion
    constructor(
    // eslint-disable-next-line default-param-last
    specification = null, videoSettings) {
        this[_a] = true; // Option 1
        this.invokerId = null;
        this.myProjectId = "";
        this.myVideoId = "";
        this.outPath = "";
        this.selectors = {};
        this.audioFilePath = "";
        this.keepSourceAudio = true;
        this.assets = [];
        this.clips = [];
        this.defaults = null;
        this._videoSettings = Object.assign({}, DEFAULT_VIDEO_SETTINGS);
        if (specification) {
            Object.assign(this, plainToInstance(EditSpecification, specification));
        }
        else {
            this.clips = [];
        }
        this.videoSettings = Object.assign({}, (videoSettings ||
            (specification === null || specification === void 0 ? void 0 : specification.videoSettings) ||
            DEFAULT_VIDEO_SETTINGS));
    }
    getMissingTranslations(languageCodes) {
        // Todo
        return [];
    }
    setOutPath(fileName, extention, parameter) {
        const basePath = "";
        const languageSuffix = `${this.language}`;
        const parameterSuffix = parameter ? `${parameter}` : "";
        this.outPath = `${basePath}${fileName}_${languageSuffix}_${parameterSuffix}.${extention}`;
    }
    setLanguage(language) {
        this.language = language;
        this.clips.forEach((clip) => {
            clip.layers.forEach((layer) => {
                layer.language = language;
            });
        });
    }
    setAlphaChannel(alphaChannel) {
        this.clips.forEach((clip) => {
            clip.layers.forEach((layer) => {
                layer.alphaChannel = alphaChannel;
            });
        });
    }
    activateSubtitles() {
        this.selectors.withSubtitle = true;
        this.selectors.withoutSubtitle = false;
        this.clips.forEach((clip) => {
            clip.layers.forEach((layer) => {
                if (layer.type === LayerType.Subtitle)
                    layer.renderDisabled = false;
            });
        });
    }
    deactivateSubtitles() {
        this.selectors.withSubtitle = false;
        this.selectors.withoutSubtitle = true;
        this.clips.forEach((clip) => {
            clip.layers.forEach((layer) => {
                if (layer.type === LayerType.Subtitle)
                    layer.renderDisabled = true;
            });
        });
    }
    setVideoSettings(videoSettings) {
        this.videoSettings = videoSettings;
    }
    updateLottieAnimationDataFromPath$(skip = false) {
        if (skip) {
            return of(this);
        }
        const pathMap = this.getLottiePaths();
        if (pathMap.length === 0) {
            return of(this);
        }
        const dataList$ = pathMap.map((url) => fromFetch(url).pipe(mergeMap((response) => response.json()), map((data) => {
            return { url, data };
        })));
        const combine = forkJoin(dataList$).pipe(map((x) => {
            return { spec: this, data: x };
        }));
        return combine.pipe(map((x) => {
            const spec = EditSpecification.setLottieAnimationData(x.spec, x.data);
            return spec;
        }));
    }
    static setLottieAnimationData(spec, data) {
        return produce(spec, (draft) => {
            draft.setLottieDataObj(data);
        });
    }
    getLottiePaths() {
        const result = [];
        this.clips.forEach((clip) => {
            clip.layers.forEach((layer) => {
                if (layer.type === LayerType.Lottie &&
                    layer.path &&
                    layer.path.isValidUrl()) {
                    result.push(layer.path);
                }
            });
        });
        return result;
    }
    setLottieDataObj(lottieArray) {
        const map = new Map(lottieArray.map((i) => [i.url, i.data]));
        this.setLottieData(map);
    }
    setLottieData(lottieMap) {
        const result = this.clips.map((clip) => {
            const newLayers = clip.layers.map((layer) => {
                if (layer.type === LayerType.Lottie &&
                    layer.path &&
                    layer.path.isValidUrl() &&
                    lottieMap.has(layer.path)) {
                    const lottieData = lottieMap.get(layer.path);
                    layer = Object.assign(Object.assign({}, layer), { lottieData });
                    return layer;
                    // Layer.lottieData = lottieMap.get(layer.path);
                }
                return layer;
            });
            return Object.assign(Object.assign({}, clip), { layers: newLayers });
        });
        this.clips = result;
    }
    static compare(a, b) {
        if (!a && !b)
            return true;
        if (!a || !b)
            return false;
        return a.equals(b);
    }
    equals(other) {
        if (!other)
            return false;
        return EditSpecification.compareIEditSpecification(this.toIEditSpecification(), other.toIEditSpecification());
    }
    static compareIEditSpecification(objA, objB) {
        if ((objA === null || objA === void 0 ? void 0 : objA.md5) && (objB === null || objB === void 0 ? void 0 : objB.md5) && objA.md5 === objB.md5) {
            return true;
        }
        const ignoreKeys = [
            "myProjectId",
            "myVideoId",
            // 'zindex',
            "width",
            "height",
        ];
        const diff = deepCompare(objA, objB, ignoreKeys);
        const different = diff.different.filter((item) => {
            return !ignoreKeys.find((key) => item.toLowerCase().includes(key.toLowerCase()));
        });
        const missingFromFirst = diff.missingFromFirst.filter((item) => {
            return !ignoreKeys.find((key) => item.toLowerCase().includes(key.toLowerCase()));
        });
        const missingFromSecond = diff.missingFromSecond.filter((item) => {
            return !ignoreKeys.find((key) => item.toLowerCase().includes(key.toLowerCase()));
        });
        const isDiffrent = different.length > 0 ||
            missingFromFirst.length > 0 ||
            missingFromSecond.length > 0;
        return !isDiffrent;
    }
    toIEditSpecification(projectId) {
        const iEditSpec = instanceToPlain(this);
        iEditSpec.myProjectId = projectId !== null && projectId !== void 0 ? projectId : this.myProjectId;
        iEditSpec.videoSettings = this.videoSettings;
        const md5 = this.getMd5();
        const reuslt = Object.assign(Object.assign({}, iEditSpec), { md5 });
        return reuslt;
    }
    toJSON() {
        return JSON.stringify(instanceToPlain(this.toIEditSpecification()));
    }
    getMd5() {
        const hashObj = {
            videoSettings: this.videoSettings,
            selectors: this.selectors,
            clips: this.comparableClips,
            defaults: this.defaults,
        };
        const json = JSON.stringify(hashObj);
        const md5 = hash.MD5(json);
        return md5;
    }
    clone() {
        const clone = plainToInstance(EditSpecification, _.cloneDeep(this));
        return clone;
    }
    withDefaults(defaults) {
        return produce(this, (draft) => {
            draft.defaults = defaults;
        });
        // const clone = this.clone();
        // clone.defaults = defaults;
        // return clone;
    }
    setDefaults(defaults) {
        if (defaults)
            this.defaults = defaults;
    }
    static fromILibraryItem(libItem, subtitleItem, languageCode) {
        return __awaiter(this, void 0, void 0, function* () {
            return EditSpecification.fromLibraryItem(LibraryItem.fromILibraryItem(libItem), subtitleItem ? LibraryItem.fromILibraryItem(subtitleItem) : undefined, languageCode);
        });
    }
    static fromLibraryItem(libItem, subtitleItem, languageCode) {
        var _b, _c;
        return __awaiter(this, void 0, void 0, function* () {
            if (libItem.type !== MediaType.Video &&
                libItem.type !== MediaType.Audio &&
                libItem.type !== MediaType.Picture)
                throw new Error(`Library item is not a video, audio or image. ${libItem.type}`);
            if (!libItem.asset)
                throw new Error("Library item has no asset");
            const assets = [
                {
                    key: { id: libItem.id, mediaType: libItem.type },
                    value: libItem.asset,
                },
            ];
            if (subtitleItem === null || subtitleItem === void 0 ? void 0 : subtitleItem.asset) {
                assets.push({
                    key: { id: subtitleItem.id, mediaType: subtitleItem.type },
                    value: subtitleItem.asset,
                });
            }
            const videoSettings = Object.assign(Object.assign({}, DEFAULT_VIDEO_SETTINGS), libItem.asset.videoSettings);
            const durationInSeconds = (_b = libItem.asset.durationInSeconds) !== null && _b !== void 0 ? _b : 10;
            const rangeOfAsset = FrameRange.fromSeconds(0, durationInSeconds, videoSettings.frameRate);
            const iSize = { width: videoSettings.width, height: videoSettings.height };
            const mainLayer = layerFromILayer({
                libId: libItem.id,
                name: libItem.name,
                type: mediaTypeToLayerType(libItem.type),
                duration: durationInSeconds,
                outerBoundaryRange: rangeOfAsset.toIFrameRange(),
                relativeRange: rangeOfAsset.toIFrameRange(),
                path: libItem.asset.sourceFile.cloudDownloadPath,
                proxyPath: (_c = libItem.asset.proxyFile) === null || _c === void 0 ? void 0 : _c.cloudDownloadPath,
                size: iSize,
                spacialBox: Box.fromIImageSettings(videoSettings).toData(),
            }, assets, videoSettings, durationInSeconds);
            if (mainLayer && languageCode && languageCode.length > 0)
                mainLayer.language = languageCode;
            const clip = Clip.fromLayer(mainLayer);
            if (subtitleItem) {
                const subtitleLayer = yield EditSpecification.libraryItemToSubtitleLayer(subtitleItem, videoSettings);
                if (subtitleLayer) {
                    if (languageCode && languageCode.length > 0)
                        subtitleLayer.language = languageCode;
                    clip.addLayer(subtitleLayer);
                }
            }
            const iEditSpec = {
                invokerId: `libraryItem-${libItem.id}`,
                selectors: {},
                videoSettings,
                assets,
                clips: [clip.toIClip(videoSettings.frameRate)],
                defaults: null,
            };
            if (languageCode)
                iEditSpec.selectors.language = languageCode;
            return plainToInstance(EditSpecification, iEditSpec);
        });
    }
    static fromIEditSpecification(data) {
        return plainToInstance(EditSpecification, data);
    }
    static fromJSON(json) {
        return plainToInstance(EditSpecification, JSON.parse(json));
    }
    static libraryItemToSubtitleLayer(libItem, videoSettings, styles) {
        var _b, _c, _d, _e, _f, _g;
        return __awaiter(this, void 0, void 0, function* () {
            // #region load subtitle file
            let webVtt = null;
            if (libItem.asset.sourceFile.jsonData &&
                libItem.asset.sourceFile.jsonData.length > 0) {
                const iWebVTT = JSON.parse(libItem.asset.sourceFile.jsonData);
                webVtt = yield WebVTT.fromIWebVTT(iWebVTT);
            }
            else if (libItem.asset.sourceFile.cloudDownloadPath) {
                webVtt = yield WebVTT.fromHttp(libItem.asset.sourceFile.cloudDownloadPath);
            }
            if (!webVtt) {
                console.error("libraryItemToSubtitleLayer -> Couldn't load subtitle file od data");
                return null;
            }
            const assets = [
                {
                    key: { id: libItem.id, mediaType: libItem.type },
                    value: libItem.asset,
                },
            ];
            const translatedSubtitles = [];
            if (libItem.asset.sourceFile.variantMap.collection) {
                // get from all variants WebVTT with fromHttp
                for (const variant of libItem.asset.sourceFile.variantMap.collection) {
                    if (variant.value.jsonData) {
                        const webVtt = yield WebVTT.fromIWebVTT(JSON.parse(variant.value.jsonData), variant.key.languageCode);
                        if (!webVtt)
                            continue;
                        webVtt.language = variant.key.languageCode;
                        const x = {
                            key: { languageCode: variant.key.languageCode },
                            value: webVtt.toIWebVTT(),
                        };
                        translatedSubtitles.push(x);
                    }
                    else if (variant.value.cloudDownloadPath) {
                        const webVtt = yield WebVTT.fromHttp(variant.value.cloudDownloadPath, variant.key.languageCode);
                        if (!webVtt)
                            continue;
                        const x = {
                            key: { languageCode: variant.key.languageCode },
                            value: webVtt.toIWebVTT(),
                        };
                        translatedSubtitles.push(x);
                    }
                }
            }
            // #endregion
            const durationInSeconds = (_c = (_b = webVtt.endInSeconds) !== null && _b !== void 0 ? _b : libItem.asset.durationInSeconds) !== null && _c !== void 0 ? _c : 30;
            const assetRange = FrameRange.fromSeconds(0, durationInSeconds, videoSettings.frameRate);
            const subtitles = [
                {
                    key: { languageCode: (_e = (_d = webVtt.language) !== null && _d !== void 0 ? _d : libItem.languageCode) !== null && _e !== void 0 ? _e : "en" },
                    value: webVtt.toIWebVTT(),
                },
                ...translatedSubtitles,
            ];
            const defaultStylesMap = new Map();
            defaultStylesMap.set("textShadow", "3px 2.5px 0px rgba(0,0,0,0.85)");
            const subtitleLayer = SubtitleLayer.fromILayer({
                libId: libItem.id,
                type: LayerType.Subtitle,
                duration: durationInSeconds,
                relativeRange: assetRange.toIFrameRange(),
                outerBoundaryRange: assetRange.toIFrameRange(),
                path: libItem.asset.sourceFile.cloudDownloadPath,
                subtitlesLocale: subtitles,
                size: (_g = (_f = libItem.videoSettings) === null || _f === void 0 ? void 0 : _f.iSize) !== null && _g !== void 0 ? _g : null,
                styles: styles !== null && styles !== void 0 ? styles : Object.fromEntries(defaultStylesMap),
                spacialBox: Box.fromIImageSettings(videoSettings).toData(),
            }, assets, videoSettings, durationInSeconds);
            return subtitleLayer;
        });
    }
    static setIds(myProjectId, editSpecification) {
        return produce(editSpecification, (draft) => {
            draft.myProjectId = myProjectId !== null && myProjectId !== void 0 ? myProjectId : null;
            draft.myVideoId = null;
        });
    }
    static default() {
        return new EditSpecification();
    }
    static empty() {
        return new EditSpecification();
    }
}
_a = immerable;
__decorate([
    Type(() => MediaAssetVariant),
    __metadata("design:type", Array)
], EditSpecification.prototype, "assets", void 0);
__decorate([
    subDocument,
    __metadata("design:type", Array)
], EditSpecification.prototype, "clips", void 0);
const deepCompare = function (a, b, ignoreKeys = []) {
    const result = {
        different: [],
        missingFromFirst: [],
        missingFromSecond: [],
    };
    if (a === null && b === null)
        return result;
    if (a === null || b !== null) {
        result.different.push("a null");
        return result;
    }
    if (a !== null || b === null) {
        result.different.push("b null");
        return result;
    }
    _.reduce(a, (result, value, key) => {
        if (Object.prototype.hasOwnProperty.call(b, key)) {
            if (_.isEqual(value, b[key])) {
                return result;
            }
            if (typeof a[key] !== typeof {} || typeof b[key] !== typeof {}) {
                // Dead end.
                result.different.push(key);
                return result;
            }
            const deeper = deepCompare(a[key], b[key], ignoreKeys);
            result.different = result.different.concat(_.map(deeper.different, (subPath) => {
                return key + "." + subPath;
            }));
            result.missingFromSecond = result.missingFromSecond.concat(_.map(deeper.missingFromSecond, (subPath) => {
                return key + "." + subPath;
            }));
            result.missingFromFirst = result.missingFromFirst.concat(_.map(deeper.missingFromFirst, (subPath) => {
                return key + "." + subPath;
            }));
            return result;
        }
        result.missingFromSecond.push(key);
        return result;
    }, result);
    _.reduce(b, (result, value, key) => {
        if (Object.prototype.hasOwnProperty.call(a, key)) {
            return result;
        }
        result.missingFromFirst.push(key);
        return result;
    }, result);
    return result;
};
export function mediaTypeToLayerType(mediaType) {
    switch (mediaType) {
        case MediaType.Audio:
            return LayerType.Audio;
        case MediaType.Video:
            return LayerType.Video;
        case MediaType.Picture:
            return LayerType.Image;
        case MediaType.Lottie:
            return LayerType.Lottie;
        default:
            throw new Error(`Unknown mediaType: ${mediaType}`);
    }
}
export function layerTypeToMediaType(layerType) {
    switch (layerType) {
        case LayerType.Audio:
            return MediaType.Audio;
        case LayerType.Video:
            return MediaType.Video;
        case LayerType.Image:
            return MediaType.Picture;
        case LayerType.Lottie:
            return MediaType.Lottie;
        default:
            throw new Error(`Unknown layerType: ${layerType}`);
    }
}
//# sourceMappingURL=editSpecification.js.map