import "reflect-metadata";
import { immerable } from "immer";
import { FrameRange } from "./frameRange.js";
import { FrameRangeCollection } from "./frameRangeCollection.js";
export interface IFrameRangeScaledItem {
    range: FrameRange;
    scaledRange: FrameRange;
}
export declare class FrameRangeItemCollection<T extends IFrameRangeScaledItem> {
    [immerable]: boolean;
    collection: T[];
    get empty(): boolean;
    get lastItem(): T;
    get lastFrame(): number;
    get lastFrameScaled(): number;
    append(item: T, atEnd?: boolean): void;
    findIndexContainsFrame(frame: number, scaled?: boolean): number;
    includingFrame(frame: number, scaled?: boolean): T[];
    leftOfFrame(frame: number, scaled?: boolean): T[];
    leftOfAndIncludingFrame(frame: number, scaled?: boolean): T[];
    rightOfFrame(frame: number, scaled?: boolean): T[];
    rightOfAndIncludingFrame(frame: number, scaled?: boolean): T[];
    toFrameRangeCollection(): FrameRangeCollection;
}
//# sourceMappingURL=frameRangeItemCollection.d.ts.map