var _a;
import { immerable } from "immer";
import { formatHex } from "./lottieAnimation.js";
export class FunctionDescription {
    constructor(name, value) {
        this.name = name;
        this[_a] = true; // Option 1
        this.parameters = [];
        this.name = name;
        this.fillParameters(value);
    }
    fillParameters(value) {
        if (!value)
            return;
        if (typeof value !== "string")
            return;
        // Find the index of the opening parenthesis "("
        const startIndex = value.indexOf("(");
        // If no opening parenthesis is found, return early
        if (startIndex === -1)
            return;
        // Extract the function name
        this.name = value.substring(0, startIndex);
        // Extract the parameters using a regular expression
        const parametersMatch = value.match(/\(([^)]+)\)/);
        // If no parameters are found, return early
        if (!parametersMatch)
            return;
        // Remove spaces and parentheses from the matched parameters
        const cleanedParameters = parametersMatch[1].replace(/\s+/g, "");
        // Split the cleaned parameters into an array
        this.parameters = cleanedParameters.split(",");
    }
    static getColorOptions(input) {
        if (!input)
            return [];
        const options = input
            .filter((x) => x.name === "color")
            .map((x) => this.getColorOption(x));
        return options.filter((x) => x !== undefined);
    }
    static getColorOption(input) {
        var _b, _c, _d, _e;
        if (!input)
            return undefined;
        if (input.name !== "color")
            return undefined;
        if (input.parameters.length < 3)
            return undefined;
        return {
            theme: (_b = input.parameters.at(0)) !== null && _b !== void 0 ? _b : "",
            name: (_c = input.parameters.at(1)) !== null && _c !== void 0 ? _c : "",
            value: formatHex((_d = input.parameters.at(2)) !== null && _d !== void 0 ? _d : "#fff"),
            index: parseInt((_e = input.parameters.at(3)) !== null && _e !== void 0 ? _e : "0", 10),
        };
    }
    static getName(input) {
        if (!input)
            return undefined;
        const options = input
            .filter((x) => x.name === "name")
            .map((x) => {
            return x.parameters.at(0);
        });
        return options.at(0);
    }
}
_a = immerable;
//# sourceMappingURL=function-description.js.map