import "reflect-metadata";
import { immerable } from "immer";
import type { ICollectionDocument, IHasUsers } from "../interfaces/index.js";
export declare class HasUsers implements IHasUsers {
    [immerable]: boolean;
    users: string[];
    groups: string[];
    groupClaims: any;
    constructor(data?: Partial<IHasUsers>);
    toIHasUsers(): IHasUsers;
    addUser(user: string): void;
    removeUser(user: string): void;
    addGroup(groupId: string): boolean;
    removeGroup(groupId: string): boolean;
    private updateGroupClaims;
}
export declare function missingGroupClaims(item: ICollectionDocument): string[];
export declare function removedGroupClaims(item: ICollectionDocument): string[];
//# sourceMappingURL=hasUsers.d.ts.map