var _a;
import "reflect-metadata";
import { immerable } from "immer";
const GRP_PREFIX = "grp:";
export class HasUsers {
    constructor(data) {
        var _b, _c;
        this[_a] = true; // Option 1
        this.users = [];
        this.groups = [];
        this.groupClaims = {};
        if (data) {
            this.users = (_b = data === null || data === void 0 ? void 0 : data.users) !== null && _b !== void 0 ? _b : [];
            this.groups = (_c = data === null || data === void 0 ? void 0 : data.groups) !== null && _c !== void 0 ? _c : [];
            if (data === null || data === void 0 ? void 0 : data.groupClaims)
                this.groupClaims = data.groupClaims;
        }
    }
    toIHasUsers() {
        return {
            users: this.users,
            groups: this.groups,
            groupClaims: this.groupClaims,
        };
    }
    addUser(user) {
        if (!this.users)
            this.users = [];
        if (this.users.includes(user))
            return;
        this.users.push(user);
    }
    removeUser(user) {
        if (!this.users)
            return;
        this.users = this.users.filter((u) => u !== user);
    }
    addGroup(groupId) {
        const claim = groupId.includes(GRP_PREFIX)
            ? groupId
            : `${GRP_PREFIX}${groupId}`;
        if (!this.groups)
            this.groups = [];
        if (this.groups.includes(claim))
            return false;
        this.groups = [...this.groups, claim];
        this.updateGroupClaims();
        return true;
    }
    removeGroup(groupId) {
        var _b;
        const claimWithoupPrefix = groupId.replace(GRP_PREFIX, "");
        if (!this.groups)
            return false;
        this.groups =
            (_b = this.groups.filter((grp) => !grp.includes(claimWithoupPrefix) // && !grp.includes("grp:")
            )) !== null && _b !== void 0 ? _b : [];
        this.updateGroupClaims();
        return true;
    }
    updateGroupClaims() {
        var _b, _c;
        if (!this.groups)
            return;
        const missingClaims = missingGroupClaims(this);
        const removedClaims = removedGroupClaims(this);
        if (missingClaims.length > 0) {
            this.groupClaims = (_b = this.groupClaims) !== null && _b !== void 0 ? _b : {};
            for (const claim of missingClaims) {
                this.groupClaims[claim] = true;
            }
        }
        if (removedClaims.length > 0) {
            this.groupClaims = (_c = this.groupClaims) !== null && _c !== void 0 ? _c : {};
            for (const claim of removedClaims) {
                delete this.groupClaims[claim];
            }
        }
    }
}
_a = immerable;
export function missingGroupClaims(item) {
    if (item.groups === null ||
        item.groups === undefined ||
        item.groups.length === 0)
        return [];
    if (item.groupClaims === null || item.groupClaims === undefined)
        return item.groups;
    const missingClaims = [];
    for (const group of item.groups) {
        if (item.groupClaims[group] === undefined)
            missingClaims.push(group);
    }
    return missingClaims;
}
export function removedGroupClaims(item) {
    var _b;
    const removedClaims = [];
    if (item.groupClaims === null || item.groupClaims === undefined)
        return [];
    const groupClaims = (_b = Object.keys(item.groupClaims)) !== null && _b !== void 0 ? _b : [];
    if (item.groups === null ||
        item.groups === undefined ||
        (item.groups.length === 0 && item.groupClaims))
        return groupClaims;
    for (const claim of groupClaims) {
        if (item.groups.includes(claim) === false)
            removedClaims.push(claim);
    }
    return removedClaims;
}
//# sourceMappingURL=hasUsers.js.map