var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var _a;
import "reflect-metadata";
import { immerable } from "immer";
import { Type } from "class-transformer";
import { NumberRange } from "./number-range.js";
export class KeyframeCollection {
    constructor(collection) {
        this[_a] = true; // Option 1
        this.collection = new Map();
        if (collection)
            this.collection = collection;
    }
    scale(factor) {
        const temp = new Map(Array.from(this.collection, ([key, value]) => [key.scale(factor), value]));
        const keys = Array.from(temp, ([key, value]) => key);
        const values = Array.from(temp, ([key, value]) => value);
        return new KeyframeCollection(temp);
    }
    static fromFrameRangeCollection(values, valueSequence, scaled) {
        const result = new KeyframeCollection();
        if (scaled) {
            const collection = new Map(values.collectionScaled.map((x, index) => {
                const evenValue = index % 2 === 0 ? 0 : 1;
                const valueFromSequernceStart = valueSequence
                    ? valueSequence[index]
                    : evenValue;
                const valueFromSequernceEnd = valueSequence
                    ? valueSequence[index + 1]
                    : evenValue;
                return [
                    x,
                    new NumberRange(valueFromSequernceStart, valueFromSequernceEnd),
                ];
            }));
            result.collection = collection;
        }
        else {
            const collection = new Map(values.collection.map((x, index) => {
                const evenValue = index % 2 === 0 ? 0 : 1;
                const valueFromSequernceStart = valueSequence
                    ? valueSequence[index]
                    : evenValue;
                const valueFromSequernceEnd = valueSequence
                    ? valueSequence[index + 1]
                    : evenValue;
                return [
                    x,
                    new NumberRange(valueFromSequernceStart, valueFromSequernceEnd),
                ];
            }));
            result.collection = collection;
        }
        return result;
    }
}
_a = immerable;
__decorate([
    Type(() => Map),
    __metadata("design:type", Map)
], KeyframeCollection.prototype, "collection", void 0);
function mapping(x, index, valueSequence) {
    const evenValue = index % 2 === 0 ? 0 : 1;
    const valueFromSequernceStart = valueSequence
        ? valueSequence[index]
        : evenValue;
    const valueFromSequernceEnd = valueSequence
        ? valueSequence[index + 1]
        : evenValue;
    return [x, new NumberRange(valueFromSequernceStart, valueFromSequernceEnd)];
}
//# sourceMappingURL=keyframe-collection.js.map