import "reflect-metadata";
import { LayerType } from "../../enums/index.js";
import { AudioLayer } from "./audio.layer.js";
import { LottieLayer } from "./lottie.layer.js";
import { LowerThirdLayer } from "./lowerThird.layer.js";
import { SlideInTextLayer } from "./slideInText.layer.js";
import { SubtitleLayer } from "./subtitle.layer.js";
import { TitleLayer } from "./title.layer.js";
import { VideoLayer } from "./video.layer.js";
import { ImageLayer } from "./image.layer.js";
export function layerFromILayer(iLayer, assets, videoSettings, duration) {
    switch (iLayer.type) {
        case LayerType.Audio:
            return AudioLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.Video:
            return VideoLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.Image:
            return ImageLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.Subtitle:
            return SubtitleLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.Lottie:
            return LottieLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.LowerThird:
            return LowerThirdLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.Title:
            return TitleLayer.fromILayer(iLayer, assets, videoSettings, duration);
        case LayerType.SlideInText:
            return SlideInTextLayer.fromILayer(iLayer, assets, videoSettings, duration);
        default:
            console.error(`EditlyService.getLayerFromILayer Not implemented LayerType ${iLayer.type}`);
            throw new Error(`Not implemented LayerType ${iLayer.type}`);
    }
}
//# sourceMappingURL=layer.factory.js.map