var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var _a;
/* eslint-disable default-param-last */
/* eslint-disable no-dupe-class-members */
/* eslint complexity: ["error", 30] */
import "reflect-metadata";
import { Type } from "class-transformer";
import { immerable } from "immer";
import { PositionType, AnchorType, TimingAction, } from "../../enums/index.js";
import { NormalizedSize } from "../normalizedSize.js";
import { Size } from "../size.js";
import { TimeLineElement } from "../timeLineElement.js";
import { Transition } from "../transition.js";
import { VideoSettings } from "../videoSettings.js";
import { BoxModel } from "../boxModel.js";
import { Aspect } from "../../enums/aspect.enum.js";
import { FrameRange } from "../frameRange.js";
import { Position } from "../position.js";
import { Box } from "../boxModel/box.js";
const SNAP_TRESHOLD = 5;
export class Layer extends TimeLineElement {
    get language() {
        return this._language;
    }
    set language(value) {
        this._language = value;
        this.languageChanged();
    }
    get languages() {
        return [this.language];
    }
    get cutOrRange() {
        var _b;
        return (_b = this.cut) !== null && _b !== void 0 ? _b : FrameRange.fromStart(0, this.duration);
    }
    get position() {
        return this._position;
    }
    set position(value) {
        this._position = value;
        this.box = this.box.withPosition(value);
    }
    get size() {
        return this._size;
    }
    set size(value) {
        this._size = value;
        this.box = this.box.withSize(value);
        this.spacialBox.size = [value.width, value.height];
    }
    get name() {
        return this._name;
    }
    set name(value) {
        this._name = value;
    }
    // eslint-disable-next-line max-params
    constructor(type, layer, asset, position = null, size = null, name = "") {
        var _b, _c, _d, _e, _f, _g, _h, _j;
        super();
        this.__LAYER__ = "layer";
        this[_a] = true; // Option 1
        this.alphaChannel = false;
        this._language = "en";
        this.styles = new Map();
        this.duration = 0;
        this.lockedAtParent = false;
        this.hiddenInTimeline = false;
        this.justifyContent = "center";
        this.alignItems = "center";
        this.children = [];
        this.box = BoxModel.default("Layer.default");
        this.spacialBox = Box.default();
        this._position = Position.leftTopZero();
        this.sourceSize = null;
        this.sourceRatioFraction = null;
        this._size = NormalizedSize.fill();
        this._name = "";
        this.assetId = asset === null || asset === void 0 ? void 0 : asset.key.id;
        this.type = type;
        this.renderDisabled = (_b = layer === null || layer === void 0 ? void 0 : layer.renderDisabled) !== null && _b !== void 0 ? _b : false;
        this.renderDisabledLocal = (_c = layer === null || layer === void 0 ? void 0 : layer.renderDisabledLocal) !== null && _c !== void 0 ? _c : false;
        this.alphaChannel = (_d = layer === null || layer === void 0 ? void 0 : layer.alphaChannel) !== null && _d !== void 0 ? _d : false;
        this.language = (_e = layer === null || layer === void 0 ? void 0 : layer.language) !== null && _e !== void 0 ? _e : "en";
        if (layer === null || layer === void 0 ? void 0 : layer.position) {
            this.position = Position.fromIPosition(layer.position, Position.leftTopZero());
        }
        if (position)
            this.position = position;
        if (size) {
            this.size = size;
        }
        if (name)
            this.name = name;
        this.box.name = name;
        if (layer) {
            if (layer.id)
                this.id = layer.id;
            this.libId = layer.libId;
            this.linkedTo = layer.linkedTo;
            this.lockedAtParent = (_f = layer.lockedAtParent) !== null && _f !== void 0 ? _f : false;
            this.hiddenInTimeline = (_g = layer.hiddenInTimeline) !== null && _g !== void 0 ? _g : false;
            this.zIndex = (_h = layer.zindex) !== null && _h !== void 0 ? _h : undefined;
            this.sourceSize = layer.sourceSize;
            this.sourceRatioFraction = layer.sourceRatioFraction;
            this.durationInSeconds = layer.duration;
            if (this.duration > 0)
                this.relativeRange = new FrameRange(0, this.duration);
            if (layer.absoluteRange)
                this.absoluteRange = FrameRange.fromIFrameRange(layer.absoluteRange);
            if (layer.relativeRange)
                this.relativeRange = FrameRange.fromIFrameRange(layer.relativeRange);
            if (layer.cutRange)
                this.cut = FrameRange.fromIFrameRange(layer.cutRange);
            if (layer.innerBoundaryRange)
                this.innerBoundaryRange = FrameRange.fromIFrameRange(layer.innerBoundaryRange);
            if (layer.outerBoundaryRange)
                this.outerBoundaryRange = FrameRange.fromIFrameRange(layer.outerBoundaryRange);
            if (this.absoluteRange.isDefault() && !this.relativeRange.isDefault())
                this.absoluteRange = this.relativeRange.clone();
            this.transitions = Transition.fromITransitions(layer.transitions);
            this.box.aspect = (_j = layer.resizeMode) !== null && _j !== void 0 ? _j : Aspect.None;
            if (layer.spacialBox)
                this.spacialBox = Box.fromData(layer.spacialBox);
            if (layer.styles)
                this.styles = new Map(Object.entries(layer.styles));
            else
                this.styles = new Map();
        }
    }
    languageChanged() { }
    toBaseILayer() {
        var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
        return {
            id: (_b = this.id) !== null && _b !== void 0 ? _b : null,
            libId: (_c = this.libId) !== null && _c !== void 0 ? _c : null,
            assetId: (_d = this.assetId) !== null && _d !== void 0 ? _d : null,
            name: this.name,
            linkedTo: (_e = this.linkedTo) !== null && _e !== void 0 ? _e : null,
            lockedAtParent: (_f = this.lockedAtParent) !== null && _f !== void 0 ? _f : false,
            hiddenInTimeline: (_g = this.hiddenInTimeline) !== null && _g !== void 0 ? _g : false,
            language: this.language,
            alphaChannel: this.alphaChannel,
            renderDisabled: this.renderDisabled,
            renderDisabledLocal: this.renderDisabledLocal,
            // #region TEMPORAL
            duration: (_h = this.durationInSeconds) !== null && _h !== void 0 ? _h : null,
            absoluteRange: this.absoluteRange.toIFrameRange(),
            relativeRange: this.relativeRange.toIFrameRange(),
            cutRange: (_k = (_j = this.cut) === null || _j === void 0 ? void 0 : _j.toIFrameRange()) !== null && _k !== void 0 ? _k : null,
            innerBoundaryRange: (_m = (_l = this.innerBoundaryRange) === null || _l === void 0 ? void 0 : _l.toIFrameRange()) !== null && _m !== void 0 ? _m : null,
            outerBoundaryRange: (_p = (_o = this.outerBoundaryRange) === null || _o === void 0 ? void 0 : _o.toIFrameRange()) !== null && _p !== void 0 ? _p : null,
            // #endregion
            // #region SPATIAL
            spacialBox: this.spacialBox.toData(),
            zindex: (_q = this.zIndex) !== null && _q !== void 0 ? _q : null,
            position: (_r = this.position.toIPosition()) !== null && _r !== void 0 ? _r : null,
            size: (_s = this.box.size.toISize()) !== null && _s !== void 0 ? _s : null,
            resizeMode: this.box.aspect,
            sourceSize: (_t = this.sourceSize) !== null && _t !== void 0 ? _t : null,
            sourceRatioFraction: (_u = this.sourceRatioFraction) !== null && _u !== void 0 ? _u : null,
            // #endregion
            transitions: Transition.toITransitions(this.transitions),
            styles: Object.fromEntries(this.styles),
        };
    }
    moveToLeft(delta) {
        this.absoluteRange = this.absoluteRange.add(delta * -1).round();
        this.relativeRange = this.relativeRange.add(delta * -1).round();
    }
    moveToRight(delta) {
        this.absoluteRange = this.absoluteRange.add(delta).round();
        this.relativeRange = this.relativeRange.add(delta).round();
    }
    trimmLeft(delta, moveToRight = false, absMoveToRight = false) {
        var _b, _c, _d, _e, _f, _g;
        const clone = ((_b = this.cut) !== null && _b !== void 0 ? _b : this.outerBoundaryRange).clone();
        this.cut = clone
            .addStart(delta)
            .pushApart(this.innerBoundaryRange)
            .clamp((_c = this.outerBoundaryRange) !== null && _c !== void 0 ? _c : FrameRange.positive)
            .round();
        if (moveToRight === true) {
            this.relativeRange = this.relativeRange
                .addStart(delta)
                .pushApart(this.innerBoundaryRange)
                .limitDuration((_d = this.outerBoundaryRange) === null || _d === void 0 ? void 0 : _d.duration)
                .round();
        }
        else {
            this.relativeRange = this.relativeRange
                .subtractEnd(delta)
                .pushApart(this.innerBoundaryRange)
                .limitDuration((_e = this.outerBoundaryRange) === null || _e === void 0 ? void 0 : _e.duration)
                .round();
        }
        if (absMoveToRight === true) {
            this.absoluteRange = this.absoluteRange
                .addStart(delta)
                .pushApart(this.innerBoundaryRange)
                .limitDuration((_f = this.outerBoundaryRange) === null || _f === void 0 ? void 0 : _f.duration)
                .round();
        }
        else {
            this.absoluteRange = this.absoluteRange
                .subtractEnd(delta)
                .pushApart(this.innerBoundaryRange)
                .limitDuration((_g = this.outerBoundaryRange) === null || _g === void 0 ? void 0 : _g.duration)
                .round();
        }
        if (this.cut)
            this.cut.duration = this.relativeRange.duration;
        this.snapCutLeft();
    }
    trimmRight(delta) {
        var _b, _c;
        const modifiedAbsolute = this.absoluteRange
            .subtractEnd(delta)
            .pushApart(this.innerBoundaryRange)
            .limitDuration((_b = this.outerBoundaryRange) === null || _b === void 0 ? void 0 : _b.duration)
            .round();
        this.absoluteRange = modifiedAbsolute;
        const modifiedRelative = this.relativeRange
            .subtractEnd(delta)
            .pushApart(this.innerBoundaryRange)
            .limitDuration((_c = this.outerBoundaryRange) === null || _c === void 0 ? void 0 : _c.duration)
            .round();
        this.relativeRange = modifiedRelative;
        if (this.cut && this.cut.duration !== modifiedRelative.duration) {
            this.cut.duration = modifiedRelative.duration;
        }
    }
    snapCutLeft() {
        if (!this.cut)
            return;
        // eslint-disable-next-line no-useless-return
        if (this.cut.isEqual(this.relativeRange))
            return;
    }
    snapCutRight() {
        if (!this.cut)
            return;
        // eslint-disable-next-line no-useless-return
        if (this.relativeRange.duration === this.duration)
            return;
        // Const delta = this.relativeRange.duration - this.duration;
        // if (Math.abs(delta) < SNAP_TRESHOLD) {
        //   this.resetTrimm();
        // }
    }
    resetTrimm() {
        this.relativeRange = FrameRange.fromStart(0, this.duration);
        this.cut = FrameRange.fromStart(0, this.duration);
    }
    static toInfoString(layer) {
        if (!layer)
            return "toInfoString is missing layer";
        if (layer.toInfoString)
            return layer.toInfoString();
        return "toInfoString is missing " + layer.type;
    }
    get positionType() {
        if (this.position)
            return this.position.positionType;
        return PositionType.Static;
    }
    get textAlignment() {
        var _b, _c;
        if (!((_b = this.position) === null || _b === void 0 ? void 0 : _b.anchorX))
            return "center";
        switch ((_c = this.position) === null || _c === void 0 ? void 0 : _c.anchorX) {
            case AnchorType.Top:
                return "start";
            case AnchorType.Bottom:
                return "end";
            case AnchorType.Left:
                return "left";
            case AnchorType.Right:
                return "right";
            case AnchorType.Center:
                return "center";
            default:
                return "center";
        }
    }
    setRelativeTiming(parentInsideRange, startOffset = 0, endOffset = 0, timingAction = TimingAction.Expand) {
        const parentWithOffset = parentInsideRange
            .addPaddingLeft(startOffset)
            .addPaddingRight(endOffset);
        switch (timingAction) {
            case TimingAction.Trim:
                if (!this.relativeRange.isInside(parentWithOffset) &&
                    timingAction === TimingAction.Trim)
                    this.relativeRange = parentWithOffset;
                break;
            default:
                this.relativeRange = parentInsideRange.addRelative(this.relativeRange, timingAction);
                break;
        }
    }
    setAbsoluteTimingFromParent(parent) {
        if (!parent)
            return;
        this.absoluteRange = this.relativeRange.add(parent.absoluteRange.start);
        this.calculateAbsolutTimingOfTransitions(parent);
        this.children.forEach((child) => {
            child.setAbsoluteTimingFromParent(this);
        });
    }
    fixCutRange() {
        if (!this.cut)
            return;
        if (this.cut.start < 0)
            this.cut.start = 0;
        if (this.cut.duration < this.relativeRange.duration)
            this.cut.duration = this.relativeRange.duration;
    }
    static getlastFrameFromLayers(layers, range) {
        let lastFrame = range.end;
        layers.forEach((layer) => {
            const layerRange = range.addRelative(layer.relativeRange, TimingAction.Expand);
            if (lastFrame < layerRange.end)
                lastFrame = layerRange.end;
        });
        return lastFrame;
    }
    setAspectLayerSize(viewPort, layerSize, aspect) {
        // TODO box
        const size = Layer.getAspectSize(aspect !== null && aspect !== void 0 ? aspect : this.box.aspect, layerSize !== null && layerSize !== void 0 ? layerSize : this.box.size, viewPort);
        const normalizedSize = NormalizedSize.fromViewPort(size, viewPort);
        this.size = normalizedSize;
    }
    static aspectLayerSize(layer, videoSettings) {
        const viewPort = VideoSettings.sizeFromVideoSettings(videoSettings);
        const size = Layer.getAspectSize(layer.resizeMode, layer.size, viewPort);
        const normalizedSize = NormalizedSize.fromViewPort(size, viewPort);
        return normalizedSize;
    }
    static getAspectSize(aspect, layerSize, viewPort) {
        let size = layerSize !== null && layerSize !== void 0 ? layerSize : Size.default;
        if (aspect === Aspect.Fill)
            size = Size.aspectFill(layerSize !== null && layerSize !== void 0 ? layerSize : Size.default, viewPort);
        if (aspect === Aspect.Fit)
            size = Size.aspectFit(layerSize !== null && layerSize !== void 0 ? layerSize : Size.default, viewPort);
        return size;
    }
}
_a = immerable;
__decorate([
    Type(() => Layer),
    __metadata("design:type", Array)
], Layer.prototype, "children", void 0);
__decorate([
    Type(() => BoxModel),
    __metadata("design:type", Object)
], Layer.prototype, "box", void 0);
__decorate([
    Type(() => Box),
    __metadata("design:type", Object)
], Layer.prototype, "spacialBox", void 0);
__decorate([
    Type(() => Position),
    __metadata("design:type", Object)
], Layer.prototype, "_position", void 0);
__decorate([
    Type(() => NormalizedSize),
    __metadata("design:type", Object)
], Layer.prototype, "_size", void 0);
//# sourceMappingURL=layer.js.map