import "reflect-metadata";
import { ITextSettings, ILayer, IVideoSettings, IProperty, AssetKey } from "../../interfaces/index.js";
import { Layer } from "./layer.js";
import { NormalizedSize } from "../normalizedSize.js";
import { Position } from "../position.js";
import { MediaAssetVariant } from "../mediaAsset.js";
export declare class TitleLayer extends Layer {
    text: string;
    duration: number;
    textSettings: ITextSettings | null;
    __LAYER__: string;
    get minDuration(): number | undefined;
    get maxDuration(): number | undefined;
    get textWidth(): number;
    constructor(layer: ILayer, asset: MediaAssetVariant<AssetKey> | undefined, text: string, duration: number, position?: Position | null, size?: NormalizedSize | null, textSettings?: ITextSettings | null, name?: string);
    static fromILayer(iLayer: ILayer, assets: MediaAssetVariant<AssetKey>[], videoSettings: IVideoSettings, duration: number): Layer;
    getILayer(): ILayer;
    getTitle(): string;
    toInfoString(): string;
    getProperties(): IProperty[];
    setProperty(name: string, value: IProperty): void;
    updatePropertyValue(name: string, value: string): void;
}
//# sourceMappingURL=title.layer.d.ts.map