import "reflect-metadata";
import { AssetKey, ILayer, IProperty, ISize, IVideoSettings } from "../../interfaces/index.js";
import { Layer } from "./layer.js";
import { NormalizedSize } from "../normalizedSize.js";
import { Position } from "../position.js";
import { ElementProps } from "../../interfaces/elementProps.js";
import { MediaAssetVariant } from "../mediaAsset.js";
export declare class VideoLayer extends Layer {
    path: string;
    duration: number;
    __LAYER__: string;
    get minDuration(): number | undefined;
    get maxDuration(): number | undefined;
    videoSize?: ISize | null;
    private _volume;
    get volume(): number;
    set volume(value: number);
    proxyPath?: string | null;
    constructor(layer: ILayer, asset: MediaAssetVariant<AssetKey> | undefined, path: string, duration: number, position?: Position | null, size?: NormalizedSize | null, name?: string);
    static fromILayer(iLayer: ILayer, assets: MediaAssetVariant<AssetKey>[], videoSettings: IVideoSettings, duration: number): Layer;
    getILayer(): ILayer;
    pathSelector(isPlayer: boolean): string | undefined;
    getTitle(): string;
    getProperties(): IProperty[];
    setProperty(name: string, value: IProperty): void;
    updatePropertyValue(name: string, value: string): void;
    toInfoString(): string;
}
export declare const VideoComponent: ({ sequenceRange, index, layer, path, offthreadVideo, selectors, }: ElementProps) => import("react/jsx-runtime").JSX.Element;
export declare const PlotComponent: ({ x, y, width, height, labelX, labelY, valueX, valueY, color, }: {
    x: number;
    y: number;
    height: number;
    width: number;
    labelX: string;
    labelY: string;
    valueX: number;
    valueY: number;
    color?: string | undefined;
}) => import("react/jsx-runtime").JSX.Element;
//# sourceMappingURL=video.layer.d.ts.map