import "reflect-metadata";
import { immerable } from "immer";
import { MediaType, type IMediaAsset, type TypeParamIndexKey, type ISelectors, type IVideoMetadata } from "../interfaces/index.js";
import { LcfVariant, LocalCloudFile } from "./localCloudFile.js";
import { Transcription } from "./transcription.js";
import { HasUsers } from "./hasUsers.js";
import { VariantMap } from "./variantMap.js";
import { VideoSettings } from "./videoSettings.js";
import { WebVTT } from "./webVTT.js";
import { TimerangeInformation } from "./timerangeInformation.js";
export declare class MediaAsset extends HasUsers implements IMediaAsset {
    [immerable]: boolean;
    sourceFile: LocalCloudFile;
    derivedFiles: LcfVariant<TypeParamIndexKey>[];
    get derivedFilesMap(): VariantMap<TypeParamIndexKey, LocalCloudFile>;
    proxyFile?: LocalCloudFile;
    proxyFileLow?: LocalCloudFile;
    audioFile?: LocalCloudFile;
    normalizedAudioFile?: LocalCloudFile;
    thumbnailFile?: LocalCloudFile;
    previewStripeImageFile?: LocalCloudFile;
    transcription?: Transcription;
    isUploaded: boolean;
    version?: number | null;
    mediaType: MediaType;
    value: string;
    newRecord?: boolean | null;
    size: number;
    length: number;
    durationInSeconds: number;
    durationTicks?: number;
    durationInFrames?: number;
    inPoint?: number;
    outPoint?: number;
    videoSettings?: VideoSettings | null;
    videoMetadata?: IVideoMetadata | null;
    analysis?: TimerangeInformation<any>[] | null;
    languageCode?: string | null;
    selectors?: ISelectors;
    updateSubtitle(languageCode: string, updatedWebVtt: WebVTT): boolean;
    toIMediaAsset(): IMediaAsset;
    trackingFunction(index: number, action: MediaAsset): string;
    static fromIMediaAsset(data: IMediaAsset): MediaAsset;
    static default(): MediaAsset;
}
export declare class MediaAssetVariant<K> {
    key: K;
    value: MediaAsset;
    constructor();
}
//# sourceMappingURL=mediaAsset.d.ts.map