import "reflect-metadata";
import { immerable } from "immer";
import type { ISize } from "../interfaces/index.js";
export declare class NormalizedSize implements ISize {
    [immerable]: boolean;
    private _width;
    get width(): number;
    set width(value: number);
    get height(): number;
    set height(value: number);
    private _height;
    constructor(width: number, height: number);
    setWidthInPercent(percent: number): void;
    setHeightInPercent(percent: number): void;
    toISize(): {
        width: number;
        height: number;
    };
    toViewPortProjection(viewPort: ISize): ISize;
    static fromISize(size: ISize): NormalizedSize;
    static fill(): NormalizedSize;
    static halfWidth(): NormalizedSize;
    static halfHeight(): NormalizedSize;
    static quarter(): NormalizedSize;
    static fromViewPort(size: ISize, viewPort: ISize): NormalizedSize;
    static aspectFill(size: ISize, viewPort: ISize): NormalizedSize;
    static aspectFit(size: ISize, viewPort: ISize): NormalizedSize;
}
//# sourceMappingURL=normalizedSize.d.ts.map