import "reflect-metadata";
import { Observable } from "rxjs";
import { immerable } from "immer";
import { type ILocalCloudFile, type IVideoSettings, type IProject, type IDocumentReference } from "../interfaces/index.js";
import { CollectionDocument } from "./collectionDocument.js";
import { EditSpecification } from "./editSpecification.js";
export declare class Project extends CollectionDocument implements IProject {
    [immerable]: boolean;
    name: string;
    editSpecification: EditSpecification;
    editSpecificationJson?: string;
    videoSettings: IVideoSettings;
    subtitleActive: boolean;
    description: string;
    keywords: string;
    mainLanguage: string;
    additionalLanguages?: string[];
    progress: number;
    isFinished: boolean;
    previewStripeFile?: ILocalCloudFile;
    libraryItems?: string[];
    myVideoIds: string[];
    renderedVideos: IDocumentReference[];
    get missingTranslations(): string[];
    constructor();
    updateLottieAnimationDataFromPath$(): Observable<Project>;
    unpackEditSpecification(): void;
    static fromIProjectJson(json: string): Project;
    static fromIProject(iProject: IProject, unpackJson?: boolean): Project;
    private fallbackValues;
    static toIProject(obj: IProject | Project): IProject;
    toIProject(editSpecToJson?: boolean): IProject;
    toIProjectJson(): string;
    groupByUser(): string;
    addRenderedVideoRef(docRef: IDocumentReference): void;
    setEditSpecificationIds(): void;
    setEditSpecificationOutPath(path: string): void;
    clone(newId?: boolean): Project;
    static setEditSpecificationIds(project: Partial<IProject>): Partial<IProject>;
    static sortBy(propertyName: string): (a: any, b: any) => 0 | 1 | -1;
    static trackingFn(index: number, project: Project): string;
    toDTO(): Record<string, any>;
    static fromDTO(dto: object): Project;
}
//# sourceMappingURL=project.d.ts.map