var _a;
import "reflect-metadata";
import { immerable } from "immer";
import { VideoResolution, VideoRatioType, PixelFormat, VideoCodecType, VideoImageFormatType, VideoFileType, } from "../enums/index.js";
import { HasUsers } from "./hasUsers.js";
import { FrameRange } from "./frameRange.js";
export class ProjectElement extends HasUsers {
    constructor(element) {
        super(element);
        this[_a] = true; // Option 1
        this.id = "";
        this.createdBy = "";
        this.updatedBy = "";
        this.uid = "";
        this.name = "";
        this.description = "";
        this.text1 = "";
        this.text2 = "";
        this.isFinished = false;
        this.isLandscape = false;
        this.isMovable = false;
        this.maxLength = null;
        this.type = 0;
        this.videoSettings = {
            isLandscape: false,
            frameRate: 25,
            resolution: VideoResolution.HD,
            ratio: VideoRatioType.R16To9,
            ratioFraction: [16, 9],
            width: 1920,
            height: 1080,
            durationInFrames: 830,
            videoCodec: VideoCodecType.H264,
            videoImageFormat: VideoImageFormatType.JPEG,
            pixelFormat: PixelFormat.yuv420p,
            proresProfile: null,
            fileType: VideoFileType.mp4,
            alphaChannel: false,
        };
        this.selectedAsset = null;
        this.uploadedAsset = null;
        this.assets = [];
        this.backgroundAudio = null;
        this.clipTitle = null;
        this.lowerThird = null;
        this.tags = {};
        this.notificationToken = "";
        this.collectionPath = "";
        if (element)
            Object.assign(this, element);
    }
    getInOutPointsInFrames(fps = this.videoSettings.frameRate) {
        return new FrameRange(this.getInPointInFrames(fps), this.getOutPointInFrames(fps));
    }
    getInPointInFrames(fps = this.videoSettings.frameRate) {
        var _b, _c;
        return fps * ((_c = (_b = this.selectedAsset) === null || _b === void 0 ? void 0 : _b.inPoint) !== null && _c !== void 0 ? _c : 0);
    }
    getOutPointInFrames(fps = this.videoSettings.frameRate) {
        var _b, _c, _d, _e;
        return (fps *
            ((_e = (_c = (_b = this.selectedAsset) === null || _b === void 0 ? void 0 : _b.outPoint) !== null && _c !== void 0 ? _c : (_d = this.selectedAsset) === null || _d === void 0 ? void 0 : _d.durationInSeconds) !== null && _e !== void 0 ? _e : 0));
    }
}
_a = immerable;
//# sourceMappingURL=projectElement.js.map