import { from, of } from "rxjs";
import { concatMap, mergeMap, toArray } from "rxjs/operators";
import { TaskExecutionStrategy } from "./taskExecutionStrategy.js";
import { combineTransients } from "./task.js";
export class ParallelExecutionStrategy extends TaskExecutionStrategy {
    execute(tasks, transient, successOnAllSubSucesses) {
        return from(tasks).pipe(mergeMap((subTask) => from(subTask.execute(transient)), tasks.length), toArray(), concatMap((results) => {
            const combined = combineTransients(transient, results, successOnAllSubSucesses);
            return of(combined);
        }));
    }
}
//# sourceMappingURL=parallelExecutionStrategy.js.map