import { ITransient, IOutput, ITrace, Transient, ITask, IArgs, TaskFunction, ITaskFunction, ITaskInfo } from "../../interfaces/ITask.js";
export declare const MOCK_ACTIVE = "mockActive";
export declare const MOCK_RESULT = "mockResult";
export declare const CANCLE_ON_NULL = "cancleOnNull";
export declare const NOT_PASS_OUTPUT = "notPassOutput";
export declare const SUCCESS_ON_ALL = "successOnAll";
export declare const ARG_TAG = "@arg:";
export declare const OUTPUT_TAG = "@output:";
export interface ITaskResult {
    state: "idle" | "success" | "error";
    output: Transient;
    traceReference?: string;
}
export declare function combineTransients(mainTransient: ITransient, subsequent: ITransient[], successOnAllSubSucesses?: boolean): ITransient;
export declare class Task implements ITask {
    private _stackTrace?;
    invokerId?: string;
    invoker?: string;
    private _lastTask;
    name: string;
    active: boolean;
    input: Transient;
    output: Transient;
    inputFromPrevious: boolean;
    args: IArgs;
    taskFunction: TaskFunction;
    subsequent?: ITask[] | undefined;
    static worker: {
        createTrace(trace: ITrace, info: ITaskInfo): Promise<string>;
    };
    static registerWorker(worker: {
        createTrace(trace: ITrace, info: ITaskInfo): Promise<string>;
    }): void;
    static logger: {
        debug: (...data: any[]) => void;
        info: (...data: any[]) => void;
        log: (...data: any[]) => void;
        warn: (...data: any[]) => void;
        error: (...data: any[]) => void;
    };
    static registerLogger(logger: {
        debug: (...data: any[]) => void;
        info: (...data: any[]) => void;
        log: (...data: any[]) => void;
        warn: (...data: any[]) => void;
        error: (...data: any[]) => void;
    }): void;
    static functions: {
        name: TaskFunction;
        fn: ITaskFunction;
    }[];
    static fromITask(task: ITask | Task): Task;
    static registerFunctions(functions: {
        name: TaskFunction;
        fn: ITaskFunction;
    }[]): void;
    constructor(name: string, taskFunction: TaskFunction, active?: boolean, input?: Transient, output?: Transient, args?: IArgs, subsequent?: ITask[]);
    setParalellExecution(): void;
    then(task: ITask): this;
    addSubsequent(task: ITask | Task): void;
    executeWithTrace(info: ITaskInfo, input?: Transient, parentArgs?: IArgs, parentOutputs?: IOutput[], depth?: number): Promise<ITransient>;
    execute(transient: ITransient): Promise<ITransient>;
    private executeFunction;
    private executeSubsequent;
    printPipeline(indent?: number): this;
    queryArgs(args: IArgs, argsBacklog: IArgs, outputs: IOutput[]): IArgs;
    fromArgs(queryString: Transient, args: IArgs): Transient;
    fromOutputs(queryString: Transient, outputs: IOutput[]): Transient;
}
export declare function mapFn(input: Transient, output: Transient, args?: IArgs): Promise<Transient>;
export declare function createTrace(trace: ITrace, info: ITaskInfo): Promise<string>;
//# sourceMappingURL=task.d.ts.map