import "reflect-metadata";
import { immerable } from "immer";
export interface ITime {
    hours: number;
    minutes: number;
    seconds: number;
    milliseconds: number;
}
export declare class Time implements ITime {
    [immerable]: boolean;
    hours: number;
    minutes: number;
    seconds: number;
    milliseconds: number;
    get totalMilliseconds(): number;
    get totalSeconds(): number;
    get totalMinutes(): number;
    get totalHours(): number;
    constructor(hours?: number, minutes?: number, seconds?: number, milliseconds?: number);
    add(time: ITime): Time;
    subtract(time: ITime): Time;
    multiply(factor: number): Time;
    divide(divisor: number): Time;
    clone(): Time;
    isEqualTo(time: ITime): boolean;
    isLessThan(time: ITime): boolean;
    isLessThanOrEqualTo(time: ITime): boolean;
    isGreaterThan(time: ITime): boolean;
    isGreaterThanOrEqualTo(time: ITime): boolean;
    toString(): string;
    static fromString(timeString?: string): Time;
    static fromITime(time: ITime): Time;
    static min(): Time;
    static max(): Time;
    static fromMilliseconds(milliseconds: number): Time;
    static fromSeconds(seconds: number): Time;
    static fromMinutes(minutes: number): Time;
    static fromHours(hours: number): Time;
    static fromNumberRange(number: number, numberSpace: number, duration: Time): Time;
}
//# sourceMappingURL=time.d.ts.map