import "reflect-metadata";
import { immerable } from "immer";
import type { IVariant, LanguageVersionKey, ITranscription } from "../interfaces/index.js";
import { LocalCloudFile } from "./localCloudFile.js";
import { VariantMap } from "./variantMap.js";
export declare class Transcription implements ITranscription {
    [immerable]: boolean;
    transcript?: string;
    srtFile: LocalCloudFile;
    jsonFile: LocalCloudFile;
    variants: IVariant<LanguageVersionKey, ITranscription>[];
    get variantMap(): VariantMap<LanguageVersionKey, Transcription>;
    constructor(data?: Partial<ITranscription>);
    toITranscription(): ITranscription;
    static fromITranscription(data?: ITranscription): Transcription;
}
//# sourceMappingURL=transcription.d.ts.map