var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var _a;
/* eslint-disable capitalized-comments */
import "reflect-metadata";
import { immerable } from "immer";
import { Type, instanceToPlain } from "class-transformer";
import { IsOptional } from "class-validator";
import { LocalCloudFile } from "./localCloudFile.js";
import { VariantMap } from "./variantMap.js";
export class Transcription {
    get variantMap() {
        const map = new VariantMap(this.variants.map((item) => {
            return {
                key: item.key,
                value: Transcription.fromITranscription(item.value),
            };
        }));
        map.onChange = (collection) => {
            this.variants = collection.map((item) => {
                return {
                    key: item.key,
                    value: item.value.toITranscription(),
                };
            });
        };
        return map;
    }
    constructor(data) {
        this[_a] = true; // Option 1
        this.srtFile = LocalCloudFile.default();
        this.jsonFile = LocalCloudFile.default();
        this.variants = [];
        if (!data)
            return;
        this.transcript = data.transcript;
        // Initialize srtFile and jsonFile as LocalCloudFile instances if provided
        this.srtFile = data.srtFile
            ? LocalCloudFile.fromILocalCloudFile(data.srtFile)
            : LocalCloudFile.default();
        this.jsonFile = data.jsonFile
            ? LocalCloudFile.fromILocalCloudFile(data.jsonFile)
            : LocalCloudFile.default();
        if (data.variants)
            this.variants = data.variants;
    }
    toITranscription() {
        const result = instanceToPlain(this);
        delete result.variantMap;
        return result;
    }
    static fromITranscription(data) {
        const result = new Transcription(data !== null && data !== void 0 ? data : {});
        return result;
    }
}
_a = immerable;
__decorate([
    IsOptional(),
    Type(() => LocalCloudFile),
    __metadata("design:type", LocalCloudFile)
], Transcription.prototype, "srtFile", void 0);
__decorate([
    IsOptional(),
    Type(() => LocalCloudFile),
    __metadata("design:type", LocalCloudFile)
], Transcription.prototype, "jsonFile", void 0);
//# sourceMappingURL=transcription.js.map