import { describe, expect, it } from "vitest";
import { Transcription } from "./transcription.js";
const KEY_EN = { languageCode: "en", version: 1 };
const KEY_DE = { languageCode: "de", version: 1 };
const KEY_IT = { languageCode: "it", version: 1 };
const LCF = {
    filename: "deutsch.txt",
    variants: [
        {
            key: KEY_IT,
            value: { filename: "italian.txt" },
        },
    ],
};
const DATA = {
    transcript: "transcript",
    srtFile: LCF,
    jsonFile: LCF,
    variants: [
        {
            key: KEY_DE,
            value: {
                transcript: "deutsch",
                variants: [
                    {
                        key: KEY_IT,
                        value: { transcript: "italiano" },
                    },
                ],
            },
        },
    ],
};
describe("Transcription", () => {
    describe("Transcription.CTor", () => {
        it("should correctly initialize from given data", () => {
            // Arrange
            // Act
            const transcription = Transcription.fromITranscription(Object.assign({}, DATA));
            // Assert
            const iTransition = transcription.toITranscription();
            expect(iTransition).toEqual(DATA);
        });
    });
});
//# sourceMappingURL=transcription.spec.js.map