import "reflect-metadata";
import { immerable } from "immer";
import type { IVariant } from "../interfaces/index.js";
export declare const LOCKED = "LOCKED";
export interface IVariantMapMapper<K, T, KDto, TDto> {
    collection: IVariant<KDto, TDto>[];
}
export declare class VariantMapMapper<K, T, KDto, TDto> implements IVariantMapMapper<K, T, KDto, TDto> {
    [immerable]: boolean;
    collection: IVariant<KDto, TDto>[];
    fromDto: (dto: IVariant<KDto, TDto>) => IVariant<K, T>;
    toDto: (item: IVariant<K, T>) => IVariant<KDto, TDto>;
    private fromDtoKey;
    private toDtoKey;
    private _default?;
    get default(): T | undefined;
    get keys(): K[];
    get values(): T[];
    get hasValues(): boolean;
    get length(): number;
    constructor(dtoMap?: IVariant<KDto, TDto>[], fromDto?: (dto: IVariant<KDto, TDto>) => IVariant<K, T>, toDto?: (item: IVariant<K, T>) => IVariant<KDto, TDto>);
    setDefault(defaultValue: T): void;
    initMap(map: IVariant<KDto, TDto>[]): void;
    exists(key: K): boolean;
    find(expression: (key: K, item: IVariant<K, T>) => boolean): IVariant<K, T> | undefined;
    get(key: K, createIfMissing?: boolean): T | null;
    add(key: K, value: T): IVariant<K, T> | undefined;
    update(key: K, value: T): boolean;
    set(key: K, value: T): boolean;
    upsert(key: K, value: T): boolean;
    remove(key: K): boolean;
    cloneItem(key: K, newKey: K): boolean;
    static fromIVariantArray<K, T, KDto, TDto>(variants: IVariant<KDto, TDto>[], fromDto: (dto: IVariant<KDto, TDto>) => IVariant<K, T>, toDto: (item: IVariant<K, T>) => IVariant<KDto, TDto>): VariantMapMapper<K, T, KDto, TDto>;
}
//# sourceMappingURL=variantMapMapper.d.ts.map