import { z } from "zod";
export declare const ITransitionSchema: z.ZodObject<{
    property: z.ZodString;
    valueFrom: z.ZodNumber;
    valueTo: z.ZodNumber;
    curve: z.ZodEnum<[import("../enums/general.js").TransitionCurve.Cut, import("../enums/general.js").TransitionCurve.Linear, import("../enums/general.js").TransitionCurve.Cubic, import("../enums/general.js").TransitionCurve.Quad]>;
    relativeRange: z.ZodObject<{
        start: z.ZodNumber;
        end: z.ZodNumber;
        anchor: z.ZodOptional<z.ZodNullable<z.ZodEnum<[import("../enums/general.js").Anchor.Start, import("../enums/general.js").Anchor.Center, import("../enums/general.js").Anchor.End]>>>;
    }, "strip", z.ZodTypeAny, {
        start: number;
        end: number;
        anchor?: import("../enums/general.js").Anchor | null | undefined;
    }, {
        start: number;
        end: number;
        anchor?: import("../enums/general.js").Anchor | null | undefined;
    }>;
}, "strip", z.ZodTypeAny, {
    relativeRange: {
        start: number;
        end: number;
        anchor?: import("../enums/general.js").Anchor | null | undefined;
    };
    property: string;
    valueFrom: number;
    valueTo: number;
    curve: import("../enums/general.js").TransitionCurve;
}, {
    relativeRange: {
        start: number;
        end: number;
        anchor?: import("../enums/general.js").Anchor | null | undefined;
    };
    property: string;
    valueFrom: number;
    valueTo: number;
    curve: import("../enums/general.js").TransitionCurve;
}>;
export declare const IClipTransitionSchema: z.ZodObject<{
    name: z.ZodString;
    duration: z.ZodNumber;
    audioInCurve: z.ZodNullable<z.ZodString>;
    audioOutCurve: z.ZodNullable<z.ZodString>;
}, "strip", z.ZodTypeAny, {
    name: string;
    duration: number;
    audioInCurve: string | null;
    audioOutCurve: string | null;
}, {
    name: string;
    duration: number;
    audioInCurve: string | null;
    audioOutCurve: string | null;
}>;
//# sourceMappingURL=transition.schema.d.ts.map