import { z } from "zod";
import { PixelFormatSchema, ProResProfileSchema, VideoCodecTypeSchema, VideoFileTypeSchema, VideoImageFormatTypeSchema, VideoRatioTypeSchema, VideoResolutionSchema, } from "../enums/index.js";
export const IImageSettingsSchema = z.object({
    isLandscape: z.boolean(),
    resolution: VideoResolutionSchema,
    ratio: VideoRatioTypeSchema,
    ratioFraction: z.tuple([z.number(), z.number()]),
    width: z.number(),
    height: z.number(),
});
export const IVideoSettingsSchema = IImageSettingsSchema.extend({
    frameRate: z.number(),
    durationInFrames: z.number(),
    videoCodec: VideoCodecTypeSchema,
    videoImageFormat: VideoImageFormatTypeSchema,
    pixelFormat: PixelFormatSchema,
    proresProfile: ProResProfileSchema.nullable().optional(),
    fileType: VideoFileTypeSchema,
    alphaChannel: z.boolean(),
});
//# sourceMappingURL=videoSettings.schema.js.map