import { z } from "zod";
export declare const VideoStripPropsSchema: z.ZodObject<{
    editSpecificationJson: z.ZodString;
    editSpecification: z.ZodAny;
    videoSettings: z.ZodObject<{
        ratio: z.ZodUnion<[z.ZodLiteral<import("../index.js").VideoRatioType.R16To9>, z.ZodLiteral<import("../index.js").VideoRatioType.R9To16>, z.ZodLiteral<import("../index.js").VideoRatioType.R4To3>, z.ZodLiteral<import("../index.js").VideoRatioType.R3To4>, z.ZodLiteral<import("../index.js").VideoRatioType.R5To4>, z.ZodLiteral<import("../index.js").VideoRatioType.R1To1>, z.ZodLiteral<import("../index.js").VideoRatioType.RCustom>]>;
        isLandscape: z.ZodBoolean;
        resolution: z.ZodEnum<[import("../index.js").VideoResolution._8K, import("../index.js").VideoResolution.UHD, import("../index.js").VideoResolution.HD, import("../index.js").VideoResolution.QHD, import("../index.js").VideoResolution.SD]>;
        ratioFraction: z.ZodTuple<[z.ZodNumber, z.ZodNumber], null>;
        width: z.ZodNumber;
        height: z.ZodNumber;
        frameRate: z.ZodNumber;
        durationInFrames: z.ZodNumber;
        videoCodec: z.ZodEnum<[import("../index.js").VideoCodecType.H264, import("../index.js").VideoCodecType.H264MKV, import("../index.js").VideoCodecType.H265, import("../index.js").VideoCodecType.ProRes, import("../index.js").VideoCodecType.VP8, import("../index.js").VideoCodecType.VP9, import("../index.js").VideoCodecType.GIF]>;
        videoImageFormat: z.ZodEnum<[import("../index.js").VideoImageFormatType.JPEG, import("../index.js").VideoImageFormatType.PNG, import("../index.js").VideoImageFormatType.NONE]>;
        pixelFormat: z.ZodEnum<[import("../index.js").PixelFormat.yuv420p, import("../index.js").PixelFormat.yuva420p, import("../index.js").PixelFormat.yuv422p, import("../index.js").PixelFormat.yuv444p, import("../index.js").PixelFormat.yuv420p10le, import("../index.js").PixelFormat.yuv422p10le, import("../index.js").PixelFormat.yuv444p10le, import("../index.js").PixelFormat.yuva444p10le]>;
        proresProfile: z.ZodOptional<z.ZodNullable<z.ZodEnum<[import("../index.js").ProResProfile.ProRes444, import("../index.js").ProResProfile.ProRes444XQ, import("../index.js").ProResProfile.HQ, import("../index.js").ProResProfile.Standard, import("../index.js").ProResProfile.Light, import("../index.js").ProResProfile.Proxy]>>>;
        fileType: z.ZodEnum<[import("../index.js").VideoFileType.mp4, import("../index.js").VideoFileType.mov, import("../index.js").VideoFileType.mkv, import("../index.js").VideoFileType.webm, import("../index.js").VideoFileType.hevc]>;
        alphaChannel: z.ZodBoolean;
    }, "strip", z.ZodTypeAny, {
        ratio: import("../index.js").VideoRatioType;
        isLandscape: boolean;
        frameRate: number;
        resolution: import("../index.js").VideoResolution;
        ratioFraction: [number, number];
        width: number;
        height: number;
        durationInFrames: number;
        videoCodec: import("../index.js").VideoCodecType;
        videoImageFormat: import("../index.js").VideoImageFormatType;
        pixelFormat: import("../index.js").PixelFormat;
        fileType: import("../index.js").VideoFileType;
        alphaChannel: boolean;
        proresProfile?: import("../index.js").ProResProfile | null | undefined;
    }, {
        ratio: import("../index.js").VideoRatioType;
        isLandscape: boolean;
        frameRate: number;
        resolution: import("../index.js").VideoResolution;
        ratioFraction: [number, number];
        width: number;
        height: number;
        durationInFrames: number;
        videoCodec: import("../index.js").VideoCodecType;
        videoImageFormat: import("../index.js").VideoImageFormatType;
        pixelFormat: import("../index.js").PixelFormat;
        fileType: import("../index.js").VideoFileType;
        alphaChannel: boolean;
        proresProfile?: import("../index.js").ProResProfile | null | undefined;
    }>;
    clips: z.ZodArray<z.ZodAny, "many">;
    dndProps: z.ZodOptional<z.ZodObject<{
        config: z.ZodObject<{
            selectionBorderColor: z.ZodOptional<z.ZodString>;
            selectionBorderSize: z.ZodOptional<z.ZodNumber>;
            resizeHandleSize: z.ZodOptional<z.ZodNumber>;
            resizeHandleBorderSize: z.ZodOptional<z.ZodNumber>;
            resizeHandleBorderColor: z.ZodOptional<z.ZodString>;
            resizeHandleBackgroundColor: z.ZodOptional<z.ZodString>;
            sanppingThreshold: z.ZodOptional<z.ZodNumber>;
            snapPositionsX: z.ZodOptional<z.ZodArray<z.ZodNumber, "many">>;
            snapPositionsY: z.ZodOptional<z.ZodArray<z.ZodNumber, "many">>;
        }, "strip", z.ZodTypeAny, {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        }, {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        }>;
        items: z.ZodArray<z.ZodObject<{
            id: z.ZodUnion<[z.ZodNumber, z.ZodString]>;
            from: z.ZodNumber;
            durationInFrames: z.ZodNumber;
            unit: z.ZodEnum<["px", "%"]>;
            top: z.ZodNumber;
            left: z.ZodNumber;
            width: z.ZodNumber;
            height: z.ZodNumber;
            enforceRatio: z.ZodOptional<z.ZodTuple<[z.ZodNumber, z.ZodNumber], null>>;
            zIndex: z.ZodOptional<z.ZodNumber>;
            color: z.ZodString;
            isDragging: z.ZodBoolean;
        }, "strip", z.ZodTypeAny, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }>, "many">;
        setSelectedItem: z.ZodFunction<z.ZodTuple<[z.ZodUnion<[z.ZodNullable<z.ZodUnion<[z.ZodNumber, z.ZodString]>>, z.ZodFunction<z.ZodTuple<[z.ZodNullable<z.ZodUnion<[z.ZodNumber, z.ZodString]>>], z.ZodUnknown>, z.ZodNullable<z.ZodUnion<[z.ZodNumber, z.ZodString]>>>]>], z.ZodUnknown>, z.ZodVoid>;
        selectedItem: z.ZodNullable<z.ZodUnion<[z.ZodNumber, z.ZodString]>>;
        changeItem: z.ZodFunction<z.ZodTuple<[z.ZodUnion<[z.ZodNumber, z.ZodString]>, z.ZodFunction<z.ZodTuple<[z.ZodObject<{
            id: z.ZodUnion<[z.ZodNumber, z.ZodString]>;
            from: z.ZodNumber;
            durationInFrames: z.ZodNumber;
            unit: z.ZodEnum<["px", "%"]>;
            top: z.ZodNumber;
            left: z.ZodNumber;
            width: z.ZodNumber;
            height: z.ZodNumber;
            enforceRatio: z.ZodOptional<z.ZodTuple<[z.ZodNumber, z.ZodNumber], null>>;
            zIndex: z.ZodOptional<z.ZodNumber>;
            color: z.ZodString;
            isDragging: z.ZodBoolean;
        }, "strip", z.ZodTypeAny, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }>], z.ZodUnknown>, z.ZodObject<{
            id: z.ZodUnion<[z.ZodNumber, z.ZodString]>;
            from: z.ZodNumber;
            durationInFrames: z.ZodNumber;
            unit: z.ZodEnum<["px", "%"]>;
            top: z.ZodNumber;
            left: z.ZodNumber;
            width: z.ZodNumber;
            height: z.ZodNumber;
            enforceRatio: z.ZodOptional<z.ZodTuple<[z.ZodNumber, z.ZodNumber], null>>;
            zIndex: z.ZodOptional<z.ZodNumber>;
            color: z.ZodString;
            isDragging: z.ZodBoolean;
        }, "strip", z.ZodTypeAny, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }>>], z.ZodUnknown>, z.ZodVoid>;
    }, "strip", z.ZodTypeAny, {
        config: {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        };
        items: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }[];
        setSelectedItem: (args_0: string | number | ((args_0: string | number | null, ...args_1: unknown[]) => string | number | null) | null, ...args_1: unknown[]) => void;
        selectedItem: string | number | null;
        changeItem: (args_0: string | number, args_1: (args_0: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_1: unknown[]) => {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_2: unknown[]) => void;
    }, {
        config: {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        };
        items: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }[];
        setSelectedItem: (args_0: string | number | ((args_0: string | number | null, ...args_1: unknown[]) => string | number | null) | null, ...args_1: unknown[]) => void;
        selectedItem: string | number | null;
        changeItem: (args_0: string | number, args_1: (args_0: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_1: unknown[]) => {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_2: unknown[]) => void;
    }>>;
}, "strip", z.ZodTypeAny, {
    videoSettings: {
        ratio: import("../index.js").VideoRatioType;
        isLandscape: boolean;
        frameRate: number;
        resolution: import("../index.js").VideoResolution;
        ratioFraction: [number, number];
        width: number;
        height: number;
        durationInFrames: number;
        videoCodec: import("../index.js").VideoCodecType;
        videoImageFormat: import("../index.js").VideoImageFormatType;
        pixelFormat: import("../index.js").PixelFormat;
        fileType: import("../index.js").VideoFileType;
        alphaChannel: boolean;
        proresProfile?: import("../index.js").ProResProfile | null | undefined;
    };
    clips: any[];
    editSpecificationJson: string;
    editSpecification?: any;
    dndProps?: {
        config: {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        };
        items: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }[];
        setSelectedItem: (args_0: string | number | ((args_0: string | number | null, ...args_1: unknown[]) => string | number | null) | null, ...args_1: unknown[]) => void;
        selectedItem: string | number | null;
        changeItem: (args_0: string | number, args_1: (args_0: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_1: unknown[]) => {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_2: unknown[]) => void;
    } | undefined;
}, {
    videoSettings: {
        ratio: import("../index.js").VideoRatioType;
        isLandscape: boolean;
        frameRate: number;
        resolution: import("../index.js").VideoResolution;
        ratioFraction: [number, number];
        width: number;
        height: number;
        durationInFrames: number;
        videoCodec: import("../index.js").VideoCodecType;
        videoImageFormat: import("../index.js").VideoImageFormatType;
        pixelFormat: import("../index.js").PixelFormat;
        fileType: import("../index.js").VideoFileType;
        alphaChannel: boolean;
        proresProfile?: import("../index.js").ProResProfile | null | undefined;
    };
    clips: any[];
    editSpecificationJson: string;
    editSpecification?: any;
    dndProps?: {
        config: {
            selectionBorderColor?: string | undefined;
            selectionBorderSize?: number | undefined;
            resizeHandleSize?: number | undefined;
            resizeHandleBorderSize?: number | undefined;
            resizeHandleBorderColor?: string | undefined;
            resizeHandleBackgroundColor?: string | undefined;
            sanppingThreshold?: number | undefined;
            snapPositionsX?: number[] | undefined;
            snapPositionsY?: number[] | undefined;
        };
        items: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }[];
        setSelectedItem: (args_0: string | number | ((args_0: string | number | null, ...args_1: unknown[]) => string | number | null) | null, ...args_1: unknown[]) => void;
        selectedItem: string | number | null;
        changeItem: (args_0: string | number, args_1: (args_0: {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_1: unknown[]) => {
            left: number;
            top: number;
            color: string;
            id: string | number;
            width: number;
            height: number;
            durationInFrames: number;
            from: number;
            unit: "px" | "%";
            isDragging: boolean;
            enforceRatio?: [number, number] | undefined;
            zIndex?: number | undefined;
        }, ...args_2: unknown[]) => void;
    } | undefined;
}>;
//# sourceMappingURL=videoStripProps.schema.d.ts.map